export interface StyledComponentProps {
    innerRef?: (comp: any) => void;
}
export declare function FilterProps<T>(refObject: any, propsObject: any): T;
export interface IDictionary<_KeyType, _ValueType> {
    get(key: _KeyType): _ValueType;
    set(key: _KeyType, value: _ValueType): void;
    unset(key: _KeyType): void;
    containsKey(key: _KeyType): boolean;
    keys(): _KeyType[];
    values(): _ValueType[];
}
export declare class Dictionary<_KeyType, _ValueType> implements IDictionary<_KeyType, _ValueType> {
    _keys: _KeyType[];
    _values: _ValueType[];
    _dictionary: any;
    constructor(init: {
        key: _KeyType;
        value: _ValueType;
    }[]);
    set(key: _KeyType, value: _ValueType): void;
    unset(key: _KeyType): void;
    keys(): _KeyType[];
    values(): any[];
    containsKey(key: _KeyType): boolean;
    toLookup(): IDictionary<_KeyType, _ValueType>;
    get(key: _KeyType): _ValueType;
}
