export declare const SIZE_MAP: {
    none: number;
    small: number;
    medium: number;
    large: number;
    xlarge: number;
};
export declare const BOX_SIZE_MAP: {
    xxsmall: number;
    xsmall: number;
    small: number;
    medium: number;
    large: number;
    xlarge: number;
    xxlarge: number;
};
export declare const BREAKPOINTS: {
    phone: number;
    tablet: number;
    desktop: number;
};
export declare type Size = 'none' | 'small' | 'medium' | 'large' | 'xlarge';
export interface SizeObject {
    horizontal?: Size;
    vertical?: Size;
}
export declare type Breakpoint = 'mobile' | 'tablet' | 'desktop';
export interface ResponsiveSize {
    mobile?: Size | SizeObject;
    tablet?: Size | SizeObject;
    desktop?: Size | SizeObject;
}
export declare type BoxSize = 'auto' | 'xsmall' | 'small' | 'medium' | 'large' | 'xlarge' | 'xxlarge' | 'full';
export interface BoxSizeObject {
    horizontal?: BoxSize;
    vertical?: BoxSize;
}
export interface FullObject {
    horizontal?: boolean;
    vertical?: boolean;
}
export declare type Full = boolean | FullObject;
export declare type WrapOption = 'wrap' | 'wrap-reverse' | 'nowrap';
export declare type Rem = number;
export declare type Px = number;
export interface SizeStyle {
    height: string;
    width: string;
}
