/// <reference types="react" />
import * as React from 'react';
import { ICellFormatter } from './UpDefaultCellFormatter';
import { ActionType } from '../../Inputs/Button';
import { IntentType } from '../../../Common/theming/types';
export interface Action {
    type: ActionType;
    intent: IntentType;
    description: string;
    action: (row: Row) => void;
}
export interface Column {
    label: string | JSX.Element;
    field?: string;
    formatter?: ICellFormatter;
    type?: any;
    isSortable?: boolean;
    isSorted?: boolean;
    sortDir?: SortDirection;
}
export interface Row {
    isSelected?: boolean;
    value?: any;
}
export declare type Method = 'GET' | 'POST';
export declare type PaginationPosition = "top" | "bottom" | "both";
export interface exportCsv {
    fileName: string;
    textButton?: string;
}
export interface UpDataGridProps {
    injectRow?: (previous: any, next: any, colum: Column[]) => JSX.Element;
    columns: Array<Column>;
    actions?: Array<Action>;
    isSelectionEnabled?: boolean;
    isPaginationEnabled?: boolean;
    paginationPosition?: PaginationPosition;
    isOddEvenEnabled?: boolean;
    isSortEnabled?: boolean;
    rowTemplate?: any;
    data?: Array<any>;
    dataKey?: string;
    isDataFetching?: boolean;
    defaultSkip?: number;
    defaultTake?: number;
    defaultPage?: number;
    total?: number;
    exportCsv?: exportCsv;
    dataSource?: {
        query: string;
        method?: Method;
        entityKey?: string;
        orderParamName?: string;
        dirParamName?: string;
        skipParamName?: string;
        takeParamName?: string;
    };
    onPageChange?: (page: number, take: number, skip: number) => void;
    onSortChange?: (c: Column, dir: SortDirection) => void;
    onSelectionChange?: (lastChangeRow: Row, seletectedRow: Row[]) => void;
}
export interface UpDataGridState {
    data: Array<Row>;
    columns?: Array<Column>;
    page: number;
    skip: number;
    take: number;
    total: number;
    isDataFetching?: boolean;
}
export declare type SortDirection = 'ASC' | 'DESC';
export default class UpDataGrid extends React.Component<UpDataGridProps, UpDataGridState> {
    static defaultProps: UpDataGridProps;
    constructor(props: any, context: any);
    componentDidMount(): void;
    mapDataToRow: (data: any[]) => Row[];
    handleData: (data: any) => void;
    fetchData: () => void;
    getSelectedRows: () => Row[];
    onPageChange: (page: number, take: number, skip: number) => void;
    readonly seletectedRow: any[];
    onRowSelectionChange: (rowKey: number, r: Row) => void;
    onSelectionAllChange: (isSelected: boolean) => void;
    onSortChange: (c: Column, dir: SortDirection) => void;
    arraysEqual(arr1: any[], arr2: any[]): boolean;
    componentWillReceiveProps(nextProps: UpDataGridProps): void;
    render(): JSX.Element;
    refTable: HTMLTableElement;
    componentDidUpdate(prevProps: any, prevState: any): void;
    readonly isExportCsvEnable: boolean;
    readonly btnExportCsv: JSX.Element;
    onExport: (a: any) => void;
    private exportTableToCSV(table, filename, header);
    private getCsvFromTable(table, header);
}
