"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var index_1 = require("../../Display/Badge/index");
var index_2 = require("../../../Common/utils/index");
var index_3 = require("../../Display/Link/index");
var index_4 = require("../../Display/SvgIcon/index");
var moment = require("moment");
var UpDefaultCellFormatter = (function () {
    function UpDefaultCellFormatter() {
        var _this = this;
        this.getValue = function (value, column) {
            var field = column.field;
            var pathParts = field.split('.');
            var valueExtracted;
            if (pathParts.length == 1) {
                valueExtracted = value[field];
            }
            else {
                var nextValue = value[pathParts[0]];
                var nextPath = pathParts.slice(1).join('.');
                valueExtracted = _this.getValue(nextValue, nextPath);
            }
            var result = "";
            var type = column.type;
            if (field) {
                switch (type) {
                    case 'link':
                        if (!index_2.isEmpty(valueExtracted)) {
                            var href = valueExtracted;
                            if (valueExtracted.href !== undefined) {
                                valueExtracted = valueExtracted.href;
                            }
                            var icon = "link";
                            if (valueExtracted.icon !== undefined) {
                                icon = valueExtracted.icon;
                            }
                            result = React.createElement(index_3.default, { href: valueExtracted, onClick: function (e) {
                                    window.open(valueExtracted);
                                } },
                                React.createElement(index_4.default, { iconName: icon }));
                        }
                        break;
                    case 'file':
                        break;
                    case 'date':
                        break;
                    default:
                        if (valueExtracted != undefined) {
                            var _couleur = undefined;
                            if (typeof (valueExtracted['Couleur']) != 'undefined')
                                _couleur = valueExtracted['Couleur'];
                            if (_couleur == undefined) {
                                result = valueExtracted;
                            }
                            else {
                                var _libelle = '';
                                if (typeof (valueExtracted['Libelle']) != 'undefined')
                                    _libelle = valueExtracted['Libelle'];
                                if (_libelle == undefined) {
                                    _libelle = '';
                                }
                                result = React.createElement(index_1.default, { text: _libelle, background: _couleur });
                            }
                        }
                        else {
                            result = "";
                        }
                        break;
                }
            }
            return result;
        };
        this.format = function (item, column) {
            var result = item;
            if (column && column.field) {
                result = _this.getValue(item, column);
            }
            return (React.createElement("div", null, result));
        };
    }
    return UpDefaultCellFormatter;
}());
exports.default = UpDefaultCellFormatter;
var UpCellFormatter = (function (_super) {
    __extends(UpCellFormatter, _super);
    function UpCellFormatter(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.state = {};
        return _this;
    }
    UpCellFormatter.prototype.render = function () {
        var valueExtracted = this.props.value[this.props.column.field];
        if (this.props.column.formatter != null) {
            return this.props.column.formatter.format(this.props.value, this.props.column);
        }
        if (valueExtracted == null) {
            return React.createElement("span", null, this.props.children);
        }
        switch (this.props.column.type) {
            case 'link':
                if (!index_2.isEmpty(valueExtracted)) {
                    var href = valueExtracted;
                    if (valueExtracted.href !== undefined) {
                        valueExtracted = valueExtracted.href;
                    }
                    var icon = "link";
                    if (valueExtracted.icon !== undefined) {
                        icon = valueExtracted.icon;
                    }
                    return React.createElement(index_3.default, { href: valueExtracted, onClick: function (e) {
                            window.open(valueExtracted);
                        } },
                        React.createElement(index_4.default, { iconName: icon }));
                }
                break;
            case 'file':
                break;
            case 'date':
                return React.createElement("span", null, moment(valueExtracted).format("DD/MM/YYYY"));
            case 'date-time':
                return React.createElement("span", null, moment(valueExtracted).format("DD/MM/YYYY HH:mm"));
            case 'time':
                return React.createElement("span", null, moment(valueExtracted).format("HH:mm"));
            case "multilineText":
                return React.createElement("span", { style: { "whiteSpace": "pre" } }, valueExtracted);
            case "boolean":
                switch (valueExtracted) {
                    case true:
                        return React.createElement(index_1.default, { text: "Oui", background: "green" });
                    case false:
                        return React.createElement(index_1.default, { text: "Non", background: "red" });
                    default:
                        return React.createElement("span", null);
                }
            default:
                if (valueExtracted != undefined) {
                    var _couleur = undefined;
                    if (typeof (valueExtracted['Couleur']) != 'undefined')
                        _couleur = valueExtracted['Couleur'];
                    if (_couleur != null) {
                        var _libelle = '';
                        if (typeof (valueExtracted['Libelle']) != 'undefined')
                            _libelle = valueExtracted['Libelle'];
                        if (_libelle == undefined) {
                            _libelle = '';
                        }
                        return React.createElement(index_1.default, { text: _libelle, background: _couleur });
                    }
                }
                return React.createElement("span", null, valueExtracted == null ? "" : valueExtracted);
        }
        return React.createElement("div", null);
    };
    return UpCellFormatter;
}(React.Component));
exports.UpCellFormatter = UpCellFormatter;
//# sourceMappingURL=UpDefaultCellFormatter.js.map