"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var UpCheckBox_1 = require("../../../Inputs/Checkbox/UpCheckBox");
var Button_1 = require("../../../Inputs/Button");
var UpDataGridCell_1 = require("../UpDataGridCell");
var UpDefaultCellFormatter_1 = require("../UpDefaultCellFormatter");
var UpDataGridRowWithStatus = (function (_super) {
    __extends(UpDataGridRowWithStatus, _super);
    function UpDataGridRowWithStatus(props, context) {
        var _this = _super.call(this, props, context) || this;
        _this.onSelectionChange = function (isSelected) {
            if (_this.props.onSelectionChange)
                _this.props.onSelectionChange({ isSelected: isSelected, value: _this.props.value });
        };
        _this.state = {
            isSelected: false
        };
        return _this;
    }
    UpDataGridRowWithStatus.prototype.render = function () {
        var _this = this;
        var formatter = new UpDefaultCellFormatter_1.default();
        var selection = React.createElement(UpCheckBox_1.default, { options: [{ name: "up-selection", checked: this.props.isSelected === true, value: true, onChange: this.onSelectionChange }] });
        return (React.createElement("div", { className: "up-data-grid-row", style: { background: "#234556" } },
            this.props.isSelectionEnabled &&
                React.createElement(UpDataGridCell_1.default, { key: "cell-selection", value: selection, column: { label: "", formatter: formatter } }),
            this.props.columns.map(function (value, index) {
                return React.createElement(UpDataGridCell_1.default, { key: "cell-" + index, value: _this.props.value, column: value });
            }),
            this.props.actions && this.props.actions.length > 0 &&
                React.createElement(UpDataGridCell_1.default, { key: "cell-actions", value: this.props.value, column: { label: "", isSortable: false } }, this.props.actions.map(function (value, index) {
                    return React.createElement(Button_1.default, { tooltip: value.description, key: "btn-" + index, actionType: value.type, width: "icon", intent: value.intent, onClick: function () {
                            if (value.action != null) {
                                value.action({ value: _this.props.value, isSelected: _this.props.isSelected });
                            }
                        } });
                }))));
    };
    UpDataGridRowWithStatus.defaultProps = {
        isSelectionEnabled: true,
        value: {},
        isSelected: false,
        columns: [],
        actions: []
    };
    return UpDataGridRowWithStatus;
}(React.Component));
exports.default = UpDataGridRowWithStatus;
//# sourceMappingURL=UpDataGridRowWithStatus.js.map