/// <reference types="react" />
import UpGrid from './UpGrid';
import UpRow from './UpRow';
import UpCol from './UpCol';
import { ThemedProps } from '../../../Common/theming/types';
export declare type LayoutMode = 'flex' | 'float';
export declare type Alignment = 'top' | 'middle' | 'bottom';
export declare type Justification = 'start' | 'end' | 'center' | 'space-around' | 'space-between';
export interface UpGridProps extends ThemedProps {
    gutter?: number;
    type?: LayoutMode;
    style?: React.CSSProperties;
}
export interface UpGridStyledProps extends ThemedProps {
    style?: React.CSSProperties;
}
export interface ColSize {
    span?: number;
    order?: number;
    offset?: number;
    push?: number;
    pull?: number;
}
export interface UpColProps {
    className?: string;
    span?: number;
    order?: number;
    offset?: number;
    push?: number;
    pull?: number;
    xs?: number | ColSize;
    sm?: number | ColSize;
    md?: number | ColSize;
    lg?: number | ColSize;
    xl?: number | ColSize;
    prefixCls?: string;
    style?: React.CSSProperties;
}
export interface UpRowProps {
    className?: string;
    gutter?: number;
    type?: LayoutMode;
    align?: Alignment;
    justify?: Justification;
    style?: React.CSSProperties;
    prefixCls?: string;
}
export { UpGrid, UpRow, UpCol };
