"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var theming_1 = require("../../../Common/theming");
var utils_1 = require("../../../Common/utils");
var themedComponents_1 = require("../../../Common/theming/themedComponents");
var index_1 = require("../../Display/SvgIcon/index");
var classnames = require("classnames");
var BasePanel = function (props) {
    var children = props.children;
    var iconName = props.iconName;
    if (!iconName && props.disableAutoIntentIcon === false && props.theme.intentTypeIcons && props.type) {
        iconName = props.theme.intentTypeIcons[props.type];
    }
    var message = props.message;
    if (utils_1.isString(children)) {
        message = children;
        children = null;
    }
    else {
        React.Children.map(children, function (child, i) {
            if (utils_1.isString(child) && children['length'] == 1) {
                message = child;
                children = null;
            }
        });
    }
    var icon = React.createElement(index_1.default, { iconName: iconName, color: (props.theme && props.theme.colorMap) ? props.theme.colorMap[props.type] : props.theme.colorMap.defaultDark, width: props.iconSize, height: props.iconSize });
    return (React.createElement("div", { className: classnames(props.className, "up-panel") },
        props.title &&
            React.createElement("div", { className: "up-panel-header" }, props.title),
        React.createElement("div", { className: "up-panel-body" },
            iconName &&
                icon,
            message &&
                React.createElement("span", { className: "up-panel-message" }, message),
            children),
        props.footer &&
            React.createElement("div", { className: "up-panel-footer" }, props.footer)));
};
var shadow = function (props) {
    return (_a = ["\n  box-shadow: 0px 0px 1px grey;\n"], _a.raw = ["\n  box-shadow: 0px 0px 1px grey;\n"], themedComponents_1.css(_a));
    var _a;
};
var base = function (props) {
    return (_a = ["\n  text-align: left;\n  border: none;\n  display: block;\n  border-radius: ", ";\n  vertical-align: top;   \n  border: 1px solid transparent;\n  width:100%;\n  margin-bottom:10px;\n  .up-panel-header {\n    width:100%;\n    padding: 8px;\n    font-weight:700;\n    color:white;\n  }\n  .up-panel-body {\n    background: linear-gradient(to bottom, #ffffff, rgba(255, 255, 255, 0)) left no-repeat, center no-repeat ; \n    background-color: #fff;\n    padding: 20px;\n  }\n  .up-panel-message {\n    margin:10px;\n    display:inline-block\n  }\n  .up-panel-footer {\n    background: linear-gradient(to bottom, #ffffff, rgba(255, 255, 255, 0)) left no-repeat, center no-repeat ; \n    background-color: ", ";\n    border-color: ", ";\n    border-top-width:1px;\n    border-top-style:solid;\n    padding: 6px;\n  }\n  svg {\n    margin:4px 4px 4px 0px;\n    display:inline-block;\n    float:left;\n  }\n"], _a.raw = ["\n  text-align: left;\n  border: none;\n  display: block;\n  border-radius: ", ";\n  vertical-align: top;   \n  border: 1px solid transparent;\n  width:100%;\n  margin-bottom:10px;\n  .up-panel-header {\n    width:100%;\n    padding: 8px;\n    font-weight:700;\n    color:white;\n  }\n  .up-panel-body {\n    background: linear-gradient(to bottom, #ffffff, rgba(255, 255, 255, 0)) left no-repeat, center no-repeat ; \n    background-color: #fff;\n    padding: 20px;\n  }\n  .up-panel-message {\n    margin:10px;\n    display:inline-block\n  }\n  .up-panel-footer {\n    background: linear-gradient(to bottom, #ffffff, rgba(255, 255, 255, 0)) left no-repeat, center no-repeat ; \n    background-color: ", ";\n    border-color: ", ";\n    border-top-width:1px;\n    border-top-style:solid;\n    padding: 6px;\n  }\n  svg {\n    margin:4px 4px 4px 0px;\n    display:inline-block;\n    float:left;\n  }\n"], themedComponents_1.css(_a, function (props) { return props.theme.borderRadius || '4px'; }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.lightGray5 : theming_1.default.colorMap.lightGray5; }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.lightGray1 : theming_1.default.colorMap.lightGray1; }));
    var _a;
};
exports.DefaultPanel = (_a = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n    color:#111;\n    background-color: ", ";\n }\n"], _a.raw = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n    color:#111;\n    background-color: ", ";\n }\n"], themedComponents_1.default(BasePanel)(_a, function (props) { return base(props); }, function (props) { return shadow(props); }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.default : theming_1.default.colorMap.default; }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.default : theming_1.default.colorMap.default; }));
exports.PrimaryDefaultPanel = (_b = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n   background-color: ", ";\n }\n"], _b.raw = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n   background-color: ", ";\n }\n"], themedComponents_1.default(BasePanel)(_b, function (props) { return base(props); }, function (props) { return shadow(props); }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.primary : theming_1.default.colorMap.primary; }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.primary : theming_1.default.colorMap.primary; }));
exports.WarningDefaultPanel = (_c = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n   background-color: ", ";\n }\n"], _c.raw = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n   background-color: ", ";\n }\n"], themedComponents_1.default(BasePanel)(_c, function (props) { return base(props); }, function (props) { return shadow(props); }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.warning : theming_1.default.colorMap.warning; }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.warning : theming_1.default.colorMap.warning; }));
exports.SuccessDefaultPanel = (_d = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n   background-color: ", ";\n }\n"], _d.raw = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n   background-color: ", ";\n }\n"], themedComponents_1.default(BasePanel)(_d, function (props) { return base(props); }, function (props) { return shadow(props); }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.successDark : theming_1.default.colorMap.successDark; }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.success : theming_1.default.colorMap.success; }));
exports.InfoDefaultPanel = (_e = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n   background-color: ", ";\n }\n"], _e.raw = ["\n", "\n", "\nborder-color: ", ";\n .up-panel-header {\n   background-color: ", ";\n }\n"], themedComponents_1.default(BasePanel)(_e, function (props) { return base(props); }, function (props) { return shadow(props); }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.infoDark : theming_1.default.colorMap.infoDark; }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.info : theming_1.default.colorMap.info; }));
exports.DangerDefaultPanel = (_f = ["\n", "\n", "\nborder-color: ", ";\n.up-panel-header {\n   background-color: ", ";\n }\n"], _f.raw = ["\n", "\n", "\nborder-color: ", ";\n.up-panel-header {\n   background-color: ", ";\n }\n"], themedComponents_1.default(BasePanel)(_f, function (props) { return base(props); }, function (props) { return shadow(props); }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.danger : theming_1.default.colorMap.dangerDark; }, function (props) { return (props.theme.colorMap) ? props.theme.colorMap.danger : theming_1.default.colorMap.danger; }));
exports.PanelStyled = function (props) {
    var children = props.children, others = __rest(props, ["children"]);
    switch (props.type) {
        case "primary":
            return React.createElement(exports.PrimaryDefaultPanel, __assign({}, others), children);
        case "info":
            return React.createElement(exports.InfoDefaultPanel, __assign({}, others), children);
        case "warning":
            return React.createElement(exports.WarningDefaultPanel, __assign({}, others), children);
        case "danger":
            return React.createElement(exports.DangerDefaultPanel, __assign({}, others), children);
        case "success":
            return React.createElement(exports.SuccessDefaultPanel, __assign({}, others), children);
    }
    return React.createElement(exports.DefaultPanel, __assign({}, others), children);
};
var _a, _b, _c, _d, _e, _f;
//# sourceMappingURL=styles.js.map