/// <reference types="react" />
import * as React from "react";
import { AttributPolice } from "../../../Common/utils/helpers";
export interface AlertIconProps {
    IconSize: string | number;
    className?: string;
    AlertNumber: string | number;
    AlertFont?: AttributPolice;
    AlertCircle?: {
        Active: boolean;
        Color?: string;
    };
}
export interface AlertIconState {
}
export declare class AlertIcon extends React.Component<AlertIconProps, AlertIconState> {
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export interface IconProps {
    Color?: string;
    BackgroundColor?: string;
    AvecCercle?: boolean;
    IconSize?: string | number;
    className?: string;
    tabIndex?: number;
    onClick?: (event) => void;
    onMouseDown?: (event) => void;
    onFocus?: (event) => void;
    onBlur?: (event) => void;
    fontWeight?: any;
    fontStyle?: any;
    fontStrech?: any;
    lineHeight?: any;
    letterSpacing?: any;
    AlertNumber?: string | number;
    AlertFont?: AttributPolice;
    AlertCircle?: {
        Active: boolean;
        Color?: string;
    };
}
export interface IconState {
}
export declare enum DirectionEnum {
    Haut = 0,
    Bas = 1,
    Gauche = 2,
    Droite = 3,
}
export interface OrientedIconProps extends IconProps {
    Direction: DirectionEnum;
}
export interface OrientedIconState extends IconState {
}
export interface MaterialIconProps extends IconProps {
    IconName: string;
}
export interface MaterialIconState extends IconState {
}
export declare class MaterialinearIcon extends React.Component<MaterialIconProps, MaterialIconState> {
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconInformations extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconInfos extends React.Component<IconProps, IconState> {
    static defaultProps: {
        IconSize: string;
        AvecCercle: boolean;
        backgroundColor: string;
        Color: string;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconInfosWhite extends React.Component<IconProps, IconState> {
    static defaultProps: {
        IconSize: string;
        AvecCercle: boolean;
        backgroundColor: string;
        Color: string;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconSuccess extends React.Component<IconProps, IconState> {
    static defaultProps: {
        IconSize: string;
        AvecCercle: boolean;
        backgroundColor: string;
        Color: string;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconError extends React.Component<IconProps, IconState> {
    static defaultProps: {
        IconSize: string;
        AvecCercle: boolean;
        backgroundColor: string;
        Color: string;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconEdit extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconCarte extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconEntourage extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconCorrespondant extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconSalarie extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconPatient extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconUtilisateur extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconAjout extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconWarning extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconOpenInNew extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconChevron extends React.Component<OrientedIconProps, OrientedIconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconConversation extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconCheckBox_Check extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconCheckBox_Empty extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconPlaning extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconActe extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconCommentaire extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconDeconnexion extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconCarteContour extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconRecherche extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
        lineHeight: number;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconVerrou extends React.Component<IconProps, IconState> {
    static defaultProps: {
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconAlertes extends React.Component<IconProps, IconState> {
    static defaultProps: {
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconMaison extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconVieuxTelephone extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconRepresentantLegal extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconPersonneConfiance extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconSerrure extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconProcheAidant extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconCalendrier extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconOeil extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconRenouveler extends React.Component<IconProps, IconState> {
    static defaultProps: {
        Color: string;
        BackgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconLivreOuvert extends React.Component<IconProps, IconState> {
    static defaultProps: {
        IconSize: string;
        AvecCercle: boolean;
        Color: string;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconAide extends React.Component<IconProps, IconState> {
    static defaultProps: {
        IconSize: string;
        AvecCercle: boolean;
        Color: string;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconMail extends React.Component<IconProps, IconState> {
    static defaultProps: {
        IconSize: string;
        AvecCercle: boolean;
        Color: string;
    };
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconLswaLink extends React.Component<IconProps, IconState> {
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export declare class IconPercevalLink extends React.Component<IconProps, IconState> {
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export interface IconLoadingProps extends IconProps {
}
export interface IconLoadingState extends IconState {
    NewSize: number;
}
export declare class IconLoading extends React.Component<IconLoadingProps, IconLoadingState> {
    static defaultProps: {
        Color: string;
        backgroundColor: string;
        IconSize: string;
        AvecCercle: boolean;
    };
    private _relativeIconSize;
    constructor(p: any, c: any);
    componentDidMount(): void;
    render(): JSX.Element;
}
