"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var typestyle_1 = require("typestyle");
var helpers_1 = require("../../../Common/utils/helpers");
var themedComponents_1 = require("../../../Common/theming/themedComponents");
var AlertIcon = (function (_super) {
    __extends(AlertIcon, _super);
    function AlertIcon(p, c) {
        return _super.call(this, p, c) || this;
    }
    AlertIcon.prototype.render = function () {
        var fontSize = (helpers_1.getFontSizeNumber(this.props.IconSize) * 0.6).toString() + "px";
        var nbChar = this.props.AlertNumber.toString().length;
        var styleAlerteG = typestyle_1.style({
            position: "relative",
        });
        var styleAlerteNumber = typestyle_1.style({
            position: "absolute",
            top: "-0.5em",
            right: "-" + (0.3 * nbChar).toString() + "em",
            fontSize: fontSize,
        });
        if (helpers_1.isNullOrUndef(this.props.AlertFont) === false) {
            this.props.AlertFont.fontSize = fontSize;
            styleAlerteNumber += " " + helpers_1.getFontClassName(this.props.AlertFont);
        }
        if (helpers_1.isNullOrUndef(this.props.AlertCircle) === false && this.props.AlertCircle.Active) {
            styleAlerteNumber += " " + typestyle_1.style({
                padding: "0.1em 0.3em",
                borderRadius: "50%",
                backgroundColor: this.props.AlertCircle.Color,
            });
        }
        return React.createElement("span", { className: this.props.className + " " + styleAlerteG },
            this.props.children,
            React.createElement("span", { className: styleAlerteNumber }, this.props.AlertNumber));
    };
    return AlertIcon;
}(React.Component));
exports.AlertIcon = AlertIcon;
var DirectionEnum;
(function (DirectionEnum) {
    DirectionEnum[DirectionEnum["Haut"] = 0] = "Haut";
    DirectionEnum[DirectionEnum["Bas"] = 1] = "Bas";
    DirectionEnum[DirectionEnum["Gauche"] = 2] = "Gauche";
    DirectionEnum[DirectionEnum["Droite"] = 3] = "Droite";
})(DirectionEnum = exports.DirectionEnum || (exports.DirectionEnum = {}));
var MaterialinearIcon = (function (_super) {
    __extends(MaterialinearIcon, _super);
    function MaterialinearIcon(p, c) {
        return _super.call(this, p, c) || this;
    }
    MaterialinearIcon.prototype.render = function () {
        var styleFocus = typestyle_1.style({
            $nest: {
                "&:focus": {
                    outline: "none",
                },
            },
        });
        var styleIcone = typestyle_1.style({
            backgroundColor: this.props.BackgroundColor ? this.props.BackgroundColor : "",
            padding: this.props.AvecCercle ? "5px" : "0",
            borderRadius: this.props.AvecCercle ? "50%" : "0",
            cursor: this.props.onClick || this.props.onMouseDown ? "pointer" : "auto",
        }) + (this.props.className ? " " + this.props.className : "") + " "
            + helpers_1.getFontClassName({ fontSize: this.props.IconSize.toString(), color: this.props.Color,
                fontWeight: this.props.fontWeight, fontStyle: this.props.fontStyle, fontStrech: this.props.fontStrech,
                lineHeight: this.props.lineHeight, letterSpacing: this.props.letterSpacing, });
        var iconeName = "icon-" + this.props.IconName;
        return React.createElement("span", { onClick: this.props.onClick, tabIndex: this.props.tabIndex, className: styleFocus, onFocus: this.props.onFocus, onBlur: this.props.onBlur, onMouseDown: this.props.onMouseDown },
            helpers_1.isNullOrUndef(this.props.AlertNumber) ?
                React.createElement("span", { className: iconeName + " " + styleIcone }) :
                React.createElement(AlertIcon, { IconSize: this.props.IconSize, className: styleIcone, AlertNumber: this.props.AlertNumber, AlertCircle: this.props.AlertCircle, AlertFont: this.props.AlertFont },
                    React.createElement("span", { className: iconeName })),
            this.props.children);
    };
    return MaterialinearIcon;
}(React.Component));
exports.MaterialinearIcon = MaterialinearIcon;
var IconInformations = (function (_super) {
    __extends(IconInformations, _super);
    function IconInformations(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconInformations.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lclipboard-text" }));
    };
    IconInformations.defaultProps = {
        Color: "#7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "16px",
        AvecCercle: false,
    };
    return IconInformations;
}(React.Component));
exports.IconInformations = IconInformations;
var IconInfos = (function (_super) {
    __extends(IconInfos, _super);
    function IconInfos(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconInfos.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "info" }));
    };
    IconInfos.defaultProps = {
        IconSize: "12px",
        AvecCercle: false,
        backgroundColor: "#ffffff",
        Color: "#c5d0de"
    };
    return IconInfos;
}(React.Component));
exports.IconInfos = IconInfos;
var IconInfosWhite = (function (_super) {
    __extends(IconInfosWhite, _super);
    function IconInfosWhite(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconInfosWhite.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "info_outline" }));
    };
    IconInfosWhite.defaultProps = {
        IconSize: "12px",
        AvecCercle: false,
        backgroundColor: "#ffffff",
        Color: "#4a4a4a",
    };
    return IconInfosWhite;
}(React.Component));
exports.IconInfosWhite = IconInfosWhite;
var IconSuccess = (function (_super) {
    __extends(IconSuccess, _super);
    function IconSuccess(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconSuccess.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "check_circle" }));
    };
    IconSuccess.defaultProps = {
        IconSize: "12px",
        AvecCercle: false,
        backgroundColor: "#05c591",
        Color: "#ffffff"
    };
    return IconSuccess;
}(React.Component));
exports.IconSuccess = IconSuccess;
var IconError = (function (_super) {
    __extends(IconError, _super);
    function IconError(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconError.prototype.render = function () {
        var className = (helpers_1.stringIsNullOrEmpty(this.props.className) ? "" : (this.props.className + " ")) + typestyle_1.style({
            display: "inline-block",
            transform: "rotateZ(0.125turn)"
        });
        return React.createElement(MaterialinearIcon, __assign({ className: className }, this.props, { IconName: "add_circle" }));
    };
    IconError.defaultProps = {
        IconSize: "12px",
        AvecCercle: false,
        backgroundColor: "#c50e1f",
        Color: "#ffffff"
    };
    return IconError;
}(React.Component));
exports.IconError = IconError;
var IconEdit = (function (_super) {
    __extends(IconEdit, _super);
    function IconEdit(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconEdit.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "mode_edit" }));
    };
    IconEdit.defaultProps = {
        Color: "#f39100",
        BackgroundColor: "#ffffff",
        IconSize: "24px",
        AvecCercle: false,
        lineHeight: 1.33,
    };
    return IconEdit;
}(React.Component));
exports.IconEdit = IconEdit;
var IconCarte = (function (_super) {
    __extends(IconCarte, _super);
    function IconCarte(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconCarte.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "room" }));
    };
    IconCarte.defaultProps = {
        Color: "#f39100",
        BackgroundColor: "#ffffff",
        IconSize: "16px",
        AvecCercle: false,
    };
    return IconCarte;
}(React.Component));
exports.IconCarte = IconCarte;
var IconEntourage = (function (_super) {
    __extends(IconEntourage, _super);
    function IconEntourage(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconEntourage.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lusers2" }));
    };
    IconEntourage.defaultProps = {
        Color: "#ffffff",
        BackgroundColor: "#f1c40f",
        IconSize: "10px",
        AvecCercle: true,
        lineHeight: 1.2,
    };
    return IconEntourage;
}(React.Component));
exports.IconEntourage = IconEntourage;
var IconCorrespondant = (function (_super) {
    __extends(IconCorrespondant, _super);
    function IconCorrespondant(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconCorrespondant.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lfirst-aid" }));
    };
    IconCorrespondant.defaultProps = {
        Color: "#ffffff",
        BackgroundColor: "#26d5ae",
        IconSize: "10px",
        AvecCercle: true,
        lineHeight: 1.2,
    };
    return IconCorrespondant;
}(React.Component));
exports.IconCorrespondant = IconCorrespondant;
var IconSalarie = (function (_super) {
    __extends(IconSalarie, _super);
    function IconSalarie(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconSalarie.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lfirst-aid" }));
    };
    IconSalarie.defaultProps = {
        Color: "#ffffff",
        BackgroundColor: "#7ad032",
        IconSize: "10px",
        AvecCercle: true,
        lineHeight: 1.2,
    };
    return IconSalarie;
}(React.Component));
exports.IconSalarie = IconSalarie;
var IconPatient = (function (_super) {
    __extends(IconPatient, _super);
    function IconPatient(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconPatient.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Luser" }));
    };
    IconPatient.defaultProps = {
        Color: "#ffffff",
        BackgroundColor: "#4a90e2",
        IconSize: "10px",
        AvecCercle: true,
        lineHeight: 1.2,
    };
    return IconPatient;
}(React.Component));
exports.IconPatient = IconPatient;
var IconUtilisateur = (function (_super) {
    __extends(IconUtilisateur, _super);
    function IconUtilisateur(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconUtilisateur.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Luser" }));
    };
    IconUtilisateur.defaultProps = {
        Color: "#ffffff",
        BackgroundColor: "#7ad032",
        IconSize: "10px",
        AvecCercle: true,
        lineHeight: 1.2,
    };
    return IconUtilisateur;
}(React.Component));
exports.IconUtilisateur = IconUtilisateur;
var IconAjout = (function (_super) {
    __extends(IconAjout, _super);
    function IconAjout(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconAjout.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "add" }));
    };
    IconAjout.defaultProps = {
        Color: "#f39100",
        BackgroundColor: "#ffffff",
        IconSize: "24px",
        AvecCercle: false,
        lineHeight: 1.33,
    };
    return IconAjout;
}(React.Component));
exports.IconAjout = IconAjout;
var IconWarning = (function (_super) {
    __extends(IconWarning, _super);
    function IconWarning(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconWarning.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "warning" }));
    };
    IconWarning.defaultProps = {
        Color: "#f39100",
        BackgroundColor: "#ffffff",
        IconSize: "28px",
        AvecCercle: false,
    };
    return IconWarning;
}(React.Component));
exports.IconWarning = IconWarning;
var IconOpenInNew = (function (_super) {
    __extends(IconOpenInNew, _super);
    function IconOpenInNew(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconOpenInNew.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "open_in_new" }));
    };
    IconOpenInNew.defaultProps = {
        Color: "#f39100",
        BackgroundColor: "#ffffff",
        IconSize: "16px",
        AvecCercle: false,
    };
    return IconOpenInNew;
}(React.Component));
exports.IconOpenInNew = IconOpenInNew;
var IconChevron = (function (_super) {
    __extends(IconChevron, _super);
    function IconChevron(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconChevron.prototype.render = function () {
        var iconName = "keyboard_arrow_";
        switch (this.props.Direction) {
            case DirectionEnum.Haut:
                iconName += "up";
                break;
            case DirectionEnum.Bas:
                iconName += "down";
                break;
            case DirectionEnum.Gauche:
                iconName += "left";
                break;
            case DirectionEnum.Droite:
                iconName += "right";
                break;
        }
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: iconName }));
    };
    IconChevron.defaultProps = {
        Color: "#ccc8c5",
        BackgroundColor: "#ffffff",
        IconSize: "24px",
        AvecCercle: false,
    };
    return IconChevron;
}(React.Component));
exports.IconChevron = IconChevron;
var IconConversation = (function (_super) {
    __extends(IconConversation, _super);
    function IconConversation(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconConversation.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lbubbles" }));
    };
    IconConversation.defaultProps = {
        Color: "#7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "44px",
        AvecCercle: false,
        lineHeight: 1.36,
    };
    return IconConversation;
}(React.Component));
exports.IconConversation = IconConversation;
var IconCheckBox_Check = (function (_super) {
    __extends(IconCheckBox_Check, _super);
    function IconCheckBox_Check(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconCheckBox_Check.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "check_box" }));
    };
    IconCheckBox_Check.defaultProps = {
        Color: "#7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "16px",
        AvecCercle: false,
    };
    return IconCheckBox_Check;
}(React.Component));
exports.IconCheckBox_Check = IconCheckBox_Check;
var IconCheckBox_Empty = (function (_super) {
    __extends(IconCheckBox_Empty, _super);
    function IconCheckBox_Empty(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconCheckBox_Empty.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "check_box_outline_blank" }));
    };
    IconCheckBox_Empty.defaultProps = {
        Color: "#7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "16px",
        AvecCercle: false,
    };
    return IconCheckBox_Empty;
}(React.Component));
exports.IconCheckBox_Empty = IconCheckBox_Empty;
var IconPlaning = (function (_super) {
    __extends(IconPlaning, _super);
    function IconPlaning(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconPlaning.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lclock3" }));
    };
    IconPlaning.defaultProps = {
        Color: "#3f3b37",
        BackgroundColor: "#ffffff",
        IconSize: "16px",
        AvecCercle: false,
    };
    return IconPlaning;
}(React.Component));
exports.IconPlaning = IconPlaning;
var IconActe = (function (_super) {
    __extends(IconActe, _super);
    function IconActe(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconActe.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Ldocument" }));
    };
    IconActe.defaultProps = {
        Color: "#3f3b37",
        BackgroundColor: "#ffffff",
        IconSize: "16px",
        AvecCercle: false,
    };
    return IconActe;
}(React.Component));
exports.IconActe = IconActe;
var IconCommentaire = (function (_super) {
    __extends(IconCommentaire, _super);
    function IconCommentaire(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconCommentaire.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lbubble-text" }));
    };
    IconCommentaire.defaultProps = {
        Color: "#3f3b37",
        BackgroundColor: "#ffffff",
        IconSize: "16px",
        AvecCercle: false,
    };
    return IconCommentaire;
}(React.Component));
exports.IconCommentaire = IconCommentaire;
var IconDeconnexion = (function (_super) {
    __extends(IconDeconnexion, _super);
    function IconDeconnexion(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconDeconnexion.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lpower-switch" }));
    };
    IconDeconnexion.defaultProps = {
        Color: "#4a4a4a",
        IconSize: "20px",
        AvecCercle: false,
        lineHeight: 1.14,
    };
    return IconDeconnexion;
}(React.Component));
exports.IconDeconnexion = IconDeconnexion;
var IconCarteContour = (function (_super) {
    __extends(IconCarteContour, _super);
    function IconCarteContour(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconCarteContour.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lmap-marker" }));
    };
    IconCarteContour.defaultProps = {
        Color: "#ffffff",
        BackgroundColor: "#3f3b37",
        IconSize: "14px",
        AvecCercle: false,
        lineHeight: 1.14,
    };
    return IconCarteContour;
}(React.Component));
exports.IconCarteContour = IconCarteContour;
var IconRecherche = (function (_super) {
    __extends(IconRecherche, _super);
    function IconRecherche(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconRecherche.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "search" }));
    };
    IconRecherche.defaultProps = {
        Color: "#7a756f",
        BackgroundColor: "#3f3b37",
        IconSize: "24px",
        AvecCercle: false,
        lineHeight: 1.33,
    };
    return IconRecherche;
}(React.Component));
exports.IconRecherche = IconRecherche;
var IconVerrou = (function (_super) {
    __extends(IconVerrou, _super);
    function IconVerrou(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconVerrou.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Llock" }));
    };
    IconVerrou.defaultProps = {
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconVerrou;
}(React.Component));
exports.IconVerrou = IconVerrou;
var IconAlertes = (function (_super) {
    __extends(IconAlertes, _super);
    function IconAlertes(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconAlertes.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lbell" }));
    };
    IconAlertes.defaultProps = {
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconAlertes;
}(React.Component));
exports.IconAlertes = IconAlertes;
var IconMaison = (function (_super) {
    __extends(IconMaison, _super);
    function IconMaison(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconMaison.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lhome" }));
    };
    IconMaison.defaultProps = {
        Color: "7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconMaison;
}(React.Component));
exports.IconMaison = IconMaison;
var IconVieuxTelephone = (function (_super) {
    __extends(IconVieuxTelephone, _super);
    function IconVieuxTelephone(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconVieuxTelephone.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Ltelephone2" }));
    };
    IconVieuxTelephone.defaultProps = {
        Color: "7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconVieuxTelephone;
}(React.Component));
exports.IconVieuxTelephone = IconVieuxTelephone;
var IconRepresentantLegal = (function (_super) {
    __extends(IconRepresentantLegal, _super);
    function IconRepresentantLegal(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconRepresentantLegal.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Luser-lock" }));
    };
    IconRepresentantLegal.defaultProps = {
        Color: "7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconRepresentantLegal;
}(React.Component));
exports.IconRepresentantLegal = IconRepresentantLegal;
var IconPersonneConfiance = (function (_super) {
    __extends(IconPersonneConfiance, _super);
    function IconPersonneConfiance(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconPersonneConfiance.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "people_outline" }));
    };
    IconPersonneConfiance.defaultProps = {
        Color: "7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconPersonneConfiance;
}(React.Component));
exports.IconPersonneConfiance = IconPersonneConfiance;
var IconSerrure = (function (_super) {
    __extends(IconSerrure, _super);
    function IconSerrure(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconSerrure.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lkey-hole" }));
    };
    IconSerrure.defaultProps = {
        Color: "7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconSerrure;
}(React.Component));
exports.IconSerrure = IconSerrure;
var IconProcheAidant = (function (_super) {
    __extends(IconProcheAidant, _super);
    function IconProcheAidant(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconProcheAidant.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lusers-add" }));
    };
    IconProcheAidant.defaultProps = {
        Color: "7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconProcheAidant;
}(React.Component));
exports.IconProcheAidant = IconProcheAidant;
var IconCalendrier = (function (_super) {
    __extends(IconCalendrier, _super);
    function IconCalendrier(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconCalendrier.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lcalendar-full" }));
    };
    IconCalendrier.defaultProps = {
        Color: "#7a756f",
        BackgroundColor: "#ffffff",
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconCalendrier;
}(React.Component));
exports.IconCalendrier = IconCalendrier;
var IconOeil = (function (_super) {
    __extends(IconOeil, _super);
    function IconOeil(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconOeil.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "visibility" }));
    };
    IconOeil.defaultProps = {
        Color: "#f39100",
        BackgroundColor: "#ffffff",
        IconSize: "24px",
        AvecCercle: false,
    };
    return IconOeil;
}(React.Component));
exports.IconOeil = IconOeil;
var IconRenouveler = (function (_super) {
    __extends(IconRenouveler, _super);
    function IconRenouveler(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconRenouveler.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "sync" }));
    };
    IconRenouveler.defaultProps = {
        Color: "#f39100",
        BackgroundColor: "#ffffff",
        IconSize: "24px",
        AvecCercle: false,
    };
    return IconRenouveler;
}(React.Component));
exports.IconRenouveler = IconRenouveler;
var IconLivreOuvert = (function (_super) {
    __extends(IconLivreOuvert, _super);
    function IconLivreOuvert(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconLivreOuvert.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "Lbook" }));
    };
    IconLivreOuvert.defaultProps = {
        IconSize: "14px",
        AvecCercle: false,
        Color: "#4a4a4a",
    };
    return IconLivreOuvert;
}(React.Component));
exports.IconLivreOuvert = IconLivreOuvert;
var IconAide = (function (_super) {
    __extends(IconAide, _super);
    function IconAide(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconAide.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "help_outline" }));
    };
    IconAide.defaultProps = {
        IconSize: "14px",
        AvecCercle: false,
        Color: "#4a4a4a",
    };
    return IconAide;
}(React.Component));
exports.IconAide = IconAide;
var IconMail = (function (_super) {
    __extends(IconMail, _super);
    function IconMail(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconMail.prototype.render = function () {
        return React.createElement(MaterialinearIcon, __assign({}, this.props, { IconName: "mail_outline" }));
    };
    IconMail.defaultProps = {
        IconSize: "14px",
        AvecCercle: false,
        Color: "#4a4a4a",
    };
    return IconMail;
}(React.Component));
exports.IconMail = IconMail;
var IconLswaLink = (function (_super) {
    __extends(IconLswaLink, _super);
    function IconLswaLink(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconLswaLink.prototype.render = function () {
        var imgLswa = require("./logoLswa_" + this.props.IconSize + "px.png");
        var styleCurseur = typestyle_1.style({
            cursor: this.props.onClick ? "pointer" : "auto",
        });
        return React.createElement("span", { className: styleCurseur, onClick: this.props.onClick, tabIndex: this.props.tabIndex, onFocus: this.props.onFocus, onBlur: this.props.onBlur, onMouseDown: this.props.onMouseDown },
            helpers_1.isNullOrUndef(this.props.AlertNumber) ?
                React.createElement("img", { src: imgLswa }) :
                React.createElement(AlertIcon, { IconSize: this.props.IconSize, AlertNumber: this.props.AlertNumber, AlertCircle: this.props.AlertCircle, AlertFont: this.props.AlertFont },
                    React.createElement("img", { src: imgLswa })),
            this.props.children);
    };
    return IconLswaLink;
}(React.Component));
exports.IconLswaLink = IconLswaLink;
var IconPercevalLink = (function (_super) {
    __extends(IconPercevalLink, _super);
    function IconPercevalLink(p, c) {
        return _super.call(this, p, c) || this;
    }
    IconPercevalLink.prototype.render = function () {
        var imgPerceval = require("./logoPerceval_" + this.props.IconSize + "px.png");
        var styleCurseur = typestyle_1.style({
            cursor: this.props.onClick ? "pointer" : "auto",
        });
        return React.createElement("span", { className: styleCurseur, onClick: this.props.onClick, tabIndex: this.props.tabIndex, onFocus: this.props.onFocus, onBlur: this.props.onBlur, onMouseDown: this.props.onMouseDown },
            helpers_1.isNullOrUndef(this.props.AlertNumber) ?
                React.createElement("img", { src: imgPerceval }) :
                React.createElement(AlertIcon, { IconSize: this.props.IconSize, AlertNumber: this.props.AlertNumber, AlertCircle: this.props.AlertCircle, AlertFont: this.props.AlertFont },
                    React.createElement("img", { src: imgPerceval })),
            this.props.children);
    };
    return IconPercevalLink;
}(React.Component));
exports.IconPercevalLink = IconPercevalLink;
var IconLoading = (function (_super) {
    __extends(IconLoading, _super);
    function IconLoading(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this._relativeIconSize = false;
        _this.state = {
            NewSize: null,
        };
        return _this;
    }
    IconLoading.prototype.componentDidMount = function () {
        if (this._relativeIconSize) {
            var ref = this.refs.iconLoad;
            var hauteur = ref.parentNode.clientHeight;
            this.setState({ NewSize: helpers_1.getFontSizeNumber(hauteur) * helpers_1.getFontSizeNumber(this.props.IconSize) / 100 });
        }
    };
    IconLoading.prototype.render = function () {
        var tailleIcon = helpers_1.getFontSizeNumber(this.state.NewSize === null ? this.props.IconSize : this.state.NewSize);
        var largeurCercle = tailleIcon / 5.75;
        var ratioTaille = tailleIcon / 7;
        var temps = ratioTaille / Math.sqrt(ratioTaille);
        tailleIcon -= largeurCercle * 2;
        var animation = (_a = ["\n            0% {\n            transform: rotate(0deg);\n            }\n            100% {\n            transform: rotate(360deg);\n            }\n        "], _a.raw = ["\n            0% {\n            transform: rotate(0deg);\n            }\n            100% {\n            transform: rotate(360deg);\n            }\n        "], themedComponents_1.keyframes(_a));
        var styleG = typestyle_1.style({
            borderRadius: "50%",
            height: tailleIcon,
            width: tailleIcon,
            border: largeurCercle + "px solid " + this.props.Color,
            borderRight: largeurCercle + "px solid " + this.props.BackgroundColor,
            backgroundColor: this.props.BackgroundColor,
            animation: animation + " " + temps.toString() + "s linear infinite",
            "-webkit-animation": animation + " " + temps.toString() + "s linear infinite",
            display: "inline-block",
            boxSizing: "initial",
            margin: this.props.AvecCercle ? "5px" : "0",
            cursor: this.props.onClick ? "pointer" : "auto",
        });
        if (this.props.className) {
            styleG += " " + this.props.className;
        }
        return React.createElement("span", { ref: "iconLoad", onClick: this.props.onClick, tabIndex: this.props.tabIndex, onFocus: this.props.onFocus, onBlur: this.props.onBlur, onMouseDown: this.props.onMouseDown },
            helpers_1.isNullOrUndef(this.props.AlertNumber) ?
                React.createElement("span", { className: styleG }) :
                React.createElement(AlertIcon, { IconSize: this.props.IconSize, AlertNumber: this.props.AlertNumber, AlertCircle: this.props.AlertCircle, AlertFont: this.props.AlertFont },
                    React.createElement("span", { className: styleG })),
            this.props.children);
        var _a;
    };
    IconLoading.defaultProps = {
        Color: "#3f3b37",
        backgroundColor: "#ffffff",
        IconSize: "14px",
        AvecCercle: false,
    };
    return IconLoading;
}(React.Component));
exports.IconLoading = IconLoading;
//# sourceMappingURL=Icons.js.map