"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Box_1 = require("../../Containers/Box");
var Grid_1 = require("../../Containers/Grid");
var styles_1 = require("./styles");
var LoadingIndicator = (function (_super) {
    __extends(LoadingIndicator, _super);
    function LoadingIndicator(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.state = {};
        return _this;
    }
    LoadingIndicator.prototype.render = function () {
        var _displayMode = this.props.displayMode;
        if (_displayMode == null) {
            _displayMode = "inline";
        }
        var _title = this.props.title;
        if (_title == null) {
            _title = "Veuillez patienter...";
        }
        if (!this.props.isLoading && _displayMode != "zone") {
            return null;
        }
        if (_displayMode == "zone") {
            var container = {
                position: "relative",
                display: "block"
            };
            var overlay = {
                position: "absolute",
                left: 0,
                right: 0,
                top: 0,
                bottom: 0,
                backgroundColor: "rgba(0,0,0,0.4)",
                display: this.props.isLoading ? "block" : "none",
            };
            var circle = {
                padding: 40,
                textAlign: "center"
            };
            return React.createElement("div", { style: container },
                this.props.children,
                React.createElement("div", { style: overlay },
                    React.createElement("div", { style: circle },
                        React.createElement(styles_1.default, { viewBox: "0 0 48 48" },
                            React.createElement(styles_1.Circle, { cx: "24", cy: "24", r: "21", stroke: "#007acc", strokeWidth: "6", fill: "none" })))));
        }
        else if (_displayMode == "inline") {
            return React.createElement(Box_1.default, { boxSize: "auto", pad: "none", margin: 'none', alignItems: "center", justifyContent: "center" },
                React.createElement(styles_1.default, { viewBox: "0 0 48 48" },
                    React.createElement(styles_1.Circle, { cx: "24", cy: "24", r: "21", stroke: "#007acc", strokeWidth: "6", fill: "none" })),
                this.props.message &&
                    React.createElement("p", null, this.props.message));
        }
        else {
            return React.createElement("aside", { className: "loading-screen", style: { "position": "fixed", "top": 0, "right": 0, "bottom": 0, "left": 0, "zIndex": 9999, backgroundColor: "white", "opacity": 0.8 } },
                React.createElement("div", { style: { "position": "absolute", "top": "50%", "left": "40%", "marginTop": "-7em" } },
                    React.createElement(Grid_1.UpGrid, null,
                        React.createElement(Grid_1.UpRow, null,
                            React.createElement(Grid_1.UpCol, { span: 6 },
                                React.createElement(styles_1.default, { viewBox: "0 0 48 48" },
                                    React.createElement(styles_1.Circle, { cx: "24", cy: "24", r: "21", stroke: "#007acc", strokeWidth: "6", fill: "none" }))),
                            React.createElement(Grid_1.UpCol, { span: 18 },
                                React.createElement(Grid_1.UpGrid, null,
                                    React.createElement(Grid_1.UpRow, null,
                                        React.createElement(Grid_1.UpCol, { span: 24 },
                                            React.createElement("hgroup", { style: { "textShadow": "0px 0px 0.1ex" }, className: "" },
                                                React.createElement("h3", { style: { "fontSize": "22px" } },
                                                    React.createElement("span", null, _title))))),
                                    React.createElement(Grid_1.UpRow, null,
                                        React.createElement(Grid_1.UpCol, { span: 24 },
                                            React.createElement("p", { className: "loading-status text-info", style: { "textAlign": "left" } }, this.props.message)))))))));
        }
    };
    return LoadingIndicator;
}(React.Component));
exports.default = LoadingIndicator;
//# sourceMappingURL=index.js.map