/// <reference types="react" />
import "./UpMenu.scss";
import * as React from "react";
export interface UpMenuProps {
    menuItems: MenuItemData[];
    topMenuItems?: TopMenuItemProps[];
    onMenuClick?: (uri: string) => boolean | void;
    onDeconnexionClick?: () => void;
    onReglagesClick?: () => void;
    onUpClick?: () => void;
    onHomeClick?: () => void;
}
export interface UpMenuState {
    col: boolean;
}
export default class UpMenu extends React.Component<UpMenuProps, UpMenuState> {
    constructor(p: any, c: any);
    clickCollapse: () => void;
    render(): JSX.Element;
}
export interface MenuItemData {
    title: string;
    uri: string;
    icon: string;
    isSelected: boolean;
    isVisible: boolean;
    childMenuItems?: MenuItemData[];
}
export interface MenuItemProps extends MenuItemData {
    onMenuClick?: (uri: string) => boolean | void;
}
export interface MenuItemState {
    active: boolean;
}
export declare class MenuItem extends React.Component<MenuItemProps, MenuItemState> {
    constructor(p: any, c: any);
    render(): JSX.Element;
    iconClick: () => void;
    onClickA: (e: any) => void;
}
export interface SubMenuProps {
    childMenuItems?: MenuItemData[];
    onMenuClick: (uri: string) => void;
}
export interface SubMenuState {
}
export declare class SubMenu extends React.Component<SubMenuProps, SubMenuState> {
    constructor(p: any, c: any);
    render(): any;
}
export interface SubItemsProps extends MenuItemData {
    onMenuClick: (uri: string) => boolean | void;
}
export interface SubItemsState {
    active: boolean;
}
export declare class SubItems extends React.Component<SubItemsProps, SubItemsState> {
    constructor(p: any, c: any);
    render(): any;
    readonly anyChild: boolean;
    onClick: (e: any) => boolean;
    onClickA: (e: any) => void;
}
export interface TopMenuProps {
    onDeconnexionClick: () => void;
    onReglagesClick: () => void;
    onUpClick: () => void;
    onHomeClick: () => void;
    childMenuItems: TopMenuItemProps[];
}
export interface TopMenuState {
}
export declare class TopMenu extends React.Component<TopMenuProps, TopMenuState> {
    constructor(p: any, c: any);
    render(): JSX.Element;
}
export interface TopMenuItemProps {
    title: string;
    action: string | (() => void);
    icon: string;
}
export interface TopMenuItemState {
}
export declare class TopMenuItem extends React.Component<TopMenuItemProps, TopMenuItemState> {
    constructor(p: any, c: any);
    render(): JSX.Element;
}
