"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
require("./UpMenu.scss");
var React = require("react");
var UpMenu = (function (_super) {
    __extends(UpMenu, _super);
    function UpMenu(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.clickCollapse = function () {
            _this.setState({ col: !_this.state.col });
        };
        _this.state = {
            col: true,
        };
        return _this;
    }
    UpMenu.prototype.render = function () {
        var _this = this;
        var menu = this.props.menuItems.map(function (v, i) {
            return React.createElement(MenuItem, { onMenuClick: _this.props.onMenuClick, key: i, title: v.title, icon: v.icon, uri: v.uri, isSelected: v.isSelected, isVisible: v.isVisible, childMenuItems: v.childMenuItems });
        });
        return React.createElement("div", { className: "UpMenu" },
            React.createElement("div", { className: "sidebar-mini skin-up" + (this.state.col ? " sidebar-collapse" : "") },
                React.createElement(TopMenu, { childMenuItems: this.props.topMenuItems, onUpClick: this.props.onUpClick, onHomeClick: this.props.onHomeClick, onReglagesClick: this.props.onReglagesClick, onDeconnexionClick: this.props.onDeconnexionClick }),
                React.createElement("aside", { className: "main-sidebar" },
                    React.createElement("section", { className: "sidebar" },
                        React.createElement("div", { className: "user-panel" },
                            React.createElement("a", { className: "sidebar-toggle", onClick: this.clickCollapse },
                                React.createElement("i", { className: "pe p7 pe-7s-menu" }),
                                React.createElement("span", { className: "sr-only" }, "Bouton Menu"))),
                        React.createElement("ul", { className: "sidebar-menu" }, menu))),
                React.createElement("div", { className: "content-wrapper", style: { minHeight: 415 } },
                    React.createElement("section", { className: "content" }, this.props.children))));
    };
    return UpMenu;
}(React.Component));
exports.default = UpMenu;
var MenuItem = (function (_super) {
    __extends(MenuItem, _super);
    function MenuItem(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.iconClick = function () {
            _this.setState({ active: !_this.state.active });
        };
        _this.onClickA = function (e) {
            var value = _this.props.onMenuClick(_this.props.uri);
            if (value === false) {
                e.preventDefault();
            }
        };
        _this.state = { active: false };
        return _this;
    }
    MenuItem.prototype.render = function () {
        var hide = this.props.isVisible === false ? "hide " : "";
        var active = this.state.active || this.props.isSelected ? " active" : "";
        return React.createElement("li", { className: hide + "treeview" + active },
            React.createElement("a", { onClick: this.onClickA, href: this.props.uri },
                React.createElement("i", { className: this.props.icon, onClick: this.iconClick }),
                React.createElement("span", null, this.props.title)),
            React.createElement(SubMenu, { onMenuClick: this.props.onMenuClick, childMenuItems: this.props.childMenuItems }));
    };
    return MenuItem;
}(React.Component));
exports.MenuItem = MenuItem;
var SubMenu = (function (_super) {
    __extends(SubMenu, _super);
    function SubMenu(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.state = {};
        return _this;
    }
    SubMenu.prototype.render = function () {
        var _this = this;
        if (this.props.childMenuItems == null || this.props.childMenuItems.length == 0) {
            return null;
        }
        var lis = this.props.childMenuItems.map(function (v, i) {
            return React.createElement(SubItems, { key: i, onMenuClick: _this.props.onMenuClick, uri: v.uri, title: v.title, isVisible: v.isVisible, isSelected: v.isSelected, icon: v.icon, childMenuItems: v.childMenuItems });
        });
        return React.createElement("ul", { className: "treeview-menu menu-open" }, lis);
    };
    return SubMenu;
}(React.Component));
exports.SubMenu = SubMenu;
var SubItems = (function (_super) {
    __extends(SubItems, _super);
    function SubItems(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.onClick = function (e) {
            _this.setState({ active: !_this.state.active });
            e.preventDefault();
            e.stopPropagation();
            return false;
        };
        _this.onClickA = function (e) {
            var value = _this.props.onMenuClick(_this.props.uri);
            if (value === false) {
                e.preventDefault();
            }
        };
        _this.state = { active: false };
        return _this;
    }
    SubItems.prototype.render = function () {
        var hide = this.props.isVisible === false ? " hide" : "";
        var active = this.state.active || this.props.isSelected ? "active" : "";
        return React.createElement("li", { className: active + hide },
            React.createElement("a", { onClick: this.onClickA, href: this.props.uri },
                this.anyChild ?
                    React.createElement("i", { onClick: this.onClick, className: (this.state.active ? "pe-7s-angle-down" : "pe-7s-angle-right") })
                    :
                        React.createElement("i", null),
                this.props.title),
            this.anyChild ? React.createElement(SubMenu, { onMenuClick: this.props.onMenuClick, childMenuItems: this.props.childMenuItems }) : null);
    };
    Object.defineProperty(SubItems.prototype, "anyChild", {
        get: function () {
            return this.props.childMenuItems != null && this.props.childMenuItems.length != 0;
        },
        enumerable: true,
        configurable: true
    });
    return SubItems;
}(React.Component));
exports.SubItems = SubItems;
var TopMenu = (function (_super) {
    __extends(TopMenu, _super);
    function TopMenu(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.state = {};
        return _this;
    }
    TopMenu.prototype.render = function () {
        var topMenuItem = [];
        if (this.props.childMenuItems && this.props.childMenuItems.length) {
            topMenuItem = this.props.childMenuItems.map(function (v, i) {
                return React.createElement(TopMenuItem, { key: i, title: v.title, icon: v.icon, action: v.action });
            });
        }
        return React.createElement("header", { className: "main-header" },
            React.createElement("a", { onClick: this.props.onUpClick, className: "logo" },
                React.createElement("span", { className: "logo-mini" },
                    React.createElement("span", { className: "up-logo" })),
                React.createElement("span", { className: "logo-lg" },
                    React.createElement("span", { className: "up-logo" }),
                    "OneHome")),
            React.createElement("nav", { className: "navbar navbar-static-top", role: "navigation" },
                React.createElement("a", { onClick: this.props.onHomeClick, className: "sidebar-toggle", "data-toggle": "", role: "button" },
                    React.createElement("span", { className: "sr-only" }, "Bouton Menu")),
                React.createElement("div", { className: "col-md-4" },
                    React.createElement("div", { className: "input-group" },
                        React.createElement("input", { type: "text", className: "form-control", placeholder: "Nom usager, n° téléphone,..." }),
                        React.createElement("span", { className: "input-group-addon", id: "basic-addon2" },
                            React.createElement("i", { className: "pe pe-7s-search" })))),
                React.createElement("div", { className: "navbar-custom-menu" },
                    React.createElement("ul", { className: "nav navbar-nav" },
                        topMenuItem,
                        React.createElement("li", { className: "dropdown user user-menu open" },
                            React.createElement("a", { id: "imageProfil", className: "dropdown-toggle", "data-toggle": "dropdown", "aria-expanded": "true" },
                                React.createElement("span", { className: "hidden-xs" }, "St\u00E9phane ROMANO"))),
                        React.createElement("li", { title: "Réglages", "data-toggle": "tooltip", "data-placement": "bottom", "data-original-title": "Réglages" },
                            React.createElement("a", { onClick: this.props.onReglagesClick, "data-toggle": "control-sidebar" },
                                React.createElement("i", { className: "pe pe-7s-edit" }))),
                        React.createElement("li", { title: "Déconnexion", "data-toggle": "tooltip", "data-placement": "bottom" },
                            React.createElement("a", { onClick: this.props.onDeconnexionClick },
                                React.createElement("i", { className: "pe pe-7s-power" })))))));
    };
    return TopMenu;
}(React.Component));
exports.TopMenu = TopMenu;
var TopMenuItem = (function (_super) {
    __extends(TopMenuItem, _super);
    function TopMenuItem(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.state = {};
        return _this;
    }
    TopMenuItem.prototype.render = function () {
        if (typeof (this.props.action) === "string") {
            return React.createElement("li", { title: this.props.title, "data-toggle": "tooltip", "data-placement": "bottom" },
                React.createElement("a", { href: this.props.action },
                    React.createElement("i", { className: this.props.icon })));
        }
        else {
            return React.createElement("li", { title: this.props.title, "data-toggle": "tooltip", "data-placement": "bottom" },
                React.createElement("a", { onClick: this.props.action },
                    React.createElement("i", { className: this.props.icon })));
        }
    };
    return TopMenuItem;
}(React.Component));
exports.TopMenuItem = TopMenuItem;
//# sourceMappingURL=UpMenu.js.map