/// <reference types="react" />
import * as React from 'react';
export default class UpCalendarTimeline extends React.Component<any, any> {
    static defaultProps: {
        sidebarWidth: number;
        dragSnap: number;
        minResizeWidth: number;
        fixedHeader: string;
        fullUpdate: boolean;
        zIndexStart: number;
        lineHeight: number;
        headerLabelGroupHeight: number;
        headerLabelHeight: number;
        itemHeightRatio: number;
        minZoom: number;
        maxZoom: number;
        clickTolerance: number;
        canChangeGroup: boolean;
        canMove: boolean;
        canResize: string;
        useResizeHandle: boolean;
        canSelect: boolean;
        stackItems: boolean;
        traditionalZoom: boolean;
        onItemMove: any;
        onItemResize: any;
        onItemClick: any;
        onItemSelect: any;
        onCanvasClick: any;
        onItemDoubleClick: any;
        onItemContextMenu: any;
        moveResizeValidator: any;
        dayBackground: any;
        defaultTimeStart: any;
        defaultTimeEnd: any;
        itemTouchSendsClick: boolean;
        style: {};
        keys: {
            groupIdKey: string;
            groupTitleKey: string;
            itemIdKey: string;
            itemTitleKey: string;
            itemDivTitleKey: string;
            itemGroupKey: string;
            itemTimeStartKey: string;
            itemTimeEndKey: string;
        };
        timeSteps: {
            second: number;
            minute: number;
            hour: number;
            day: number;
            month: number;
            year: number;
        };
        visibleTimeStart: any;
        visibleTimeEnd: any;
        onTimeChange: (visibleTimeStart: any, visibleTimeEnd: any, updateScrollCanvas: any) => void;
        onTimeInit: any;
        onBoundsChange: any;
        children: any;
    };
    constructor(props: any);
    lastTouchDistance?: any;
    resizeEventListener?: any;
    componentDidMount(): void;
    componentWillUnmount(): void;
    singleTouchStart: any;
    lastSingleTouch: any;
    touchStart: (e: any) => void;
    touchMove: (e: any) => void;
    touchEnd: (e: any) => void;
    resize(): void;
    onScroll: () => void;
    componentWillReceiveProps(nextProps: any): void;
    updateDimensions(items: any, groups: any): void;
    updateScrollCanvas: (visibleTimeStart: any, visibleTimeEnd: any, forceUpdateDimensions: any, updatedItems: any, updatedGroups: any) => void;
    onWheel: (e: any) => void;
    zoomIn(e: any): void;
    zoomOut(e: any): void;
    changeZoom(scale: any, offset?: number): void;
    showPeriod: (from: any, unit: any) => void;
    selectItem: (item: any, clickType?: any, e?: any) => void;
    rowAndTimeFromEvent(e: any): number[];
    scrollAreaClick: (e: any) => void;
    dragItem: (item: any, dragTime: any, newGroupOrder: any) => void;
    dropItem: (item: any, dragTime: any, newGroupOrder: any) => void;
    resizingItem: (item: any, resizeTime: any, edge: any) => void;
    resizedItem: (item: any, resizeTime: any, edge: any) => void;
    handleMouseDown: (e: any) => void;
    handleMouseMove: (e: any) => void;
    handleMouseUp: (e: any) => void;
    todayLine(canvasTimeStart: any, zoom: any, canvasTimeEnd: any, canvasWidth: any, minUnit: any, height: any, headerHeight: any): JSX.Element;
    verticalLines(canvasTimeStart: any, zoom: any, canvasTimeEnd: any, canvasWidth: any, minUnit: any, timeSteps: any, height: any, headerHeight: any): JSX.Element;
    horizontalLines(canvasTimeStart: any, zoom: any, canvasTimeEnd: any, canvasWidth: any, groupHeights: any, headerHeight: any): JSX.Element;
    items(canvasTimeStart: any, zoom: any, canvasTimeEnd: any, canvasWidth: any, minUnit: any, dimensionItems: any, groupHeights: any, groupTops: any): JSX.Element;
    infoLabel(): JSX.Element | "";
    header(canvasTimeStart: any, zoom: any, canvasTimeEnd: any, canvasWidth: any, minUnit: any, timeSteps: any, headerLabelGroupHeight: any, headerLabelHeight: any): JSX.Element;
    sidebar(height: any, groupHeights: any, headerHeight: any): JSX.Element;
    stackItems(items?: any, groups?: any, canvasTimeStart?: any, visibleTimeStart?: any, visibleTimeEnd?: any, width?: any, full?: any): any;
    handleDoubleClick: (e: any) => void;
    render(): JSX.Element;
}
