"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var HorizontalLines = (function (_super) {
    __extends(HorizontalLines, _super);
    function HorizontalLines() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalLines.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return !(nextProps.canvasWidth === this.props.canvasWidth &&
            nextProps.lineHeight === this.props.lineHeight &&
            nextProps.lineCount === this.props.lineCount &&
            nextProps.groupHeights === this.props.groupHeights);
    };
    HorizontalLines.prototype.render = function () {
        var _a = this.props, lineCount = _a.lineCount, canvasWidth = _a.canvasWidth, groupHeights = _a.groupHeights, headerHeight = _a.headerHeight;
        var lines = [];
        var totalHeight = headerHeight;
        for (var i = 0; i < lineCount; i++) {
            lines.push(React.createElement("div", { key: "horizontal-line-" + i, className: i % 2 === 0 ? 'rct-hl-even' : 'rct-hl-odd', style: {
                    top: totalHeight + "px",
                    left: '0px',
                    width: canvasWidth + "px",
                    height: groupHeights[i] - 1 + "px"
                } }));
            totalHeight += groupHeights[i];
        }
        return (React.createElement("div", { className: 'rct-horizontal-lines' }, lines));
    };
    HorizontalLines.defaultProps = {
        borderWidth: 1
    };
    return HorizontalLines;
}(React.Component));
exports.default = HorizontalLines;
//# sourceMappingURL=HorizontalLines.js.map