"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("react");
var classNames = require("classnames");
var ReactTooltip = require("react-tooltip");
var utils_1 = require("../../../Common/utils");
var typestyle_1 = require("typestyle");
typestyle_1.cssRaw("\n  .up-tooltip-header {\n    padding:4px;\n    border-bottom:1px solid #111;\n    font-weight:700;\n    font-size:13px;\n    color:#111;\n    background:whitesmoke;\n  }\n  .up-tooltip-body {\n    padding:8px 0px;\n  }\n  .up-tooltip {\n    pointer-events: auto !important;\n    opacity: 0.95 !important;\n    padding:0px;\n    &:hover {\n      visibility: visible !important;\n      opacity: 1 !important;\n    }\n   }\n");
var UpTooltip = (function (_super) {
    __extends(UpTooltip, _super);
    function UpTooltip(props) {
        var _this = _super.call(this, props) || this;
        _this.getContent = function () {
            return (React.createElement("div", null,
                _this.props.title != null &&
                    React.createElement("div", { className: "up-tooltip-header" }, _this.props.title),
                React.createElement("div", { className: "up-tooltip-body" }, _this.props.content)));
        };
        return _this;
    }
    UpTooltip.prototype.render = function () {
        var _a = this.props, id = _a.id, children = _a.children, content = _a.content, others = __rest(_a, ["id", "children", "content"]);
        var _id = id;
        if (!_id) {
            _id = utils_1.GenerateId();
        }
        var childrenWithProps = React.Children.map(this.props.children, function (child) {
            if (React.isValidElement(child)) {
                return React.cloneElement(child, { "dataFor": _id });
            }
            else {
                return child;
            }
        });
        var custom = '';
        if (this.props.type == 'light') {
            custom = typestyle_1.style({
                background: "#FEFEFE !important",
                border: "1px #ccc solid",
                borderRadius: "6px",
                $nest: {
                    '&.place-top:after': {
                        borderTopColor: "#ccc !important",
                        borderTopStyle: "solid !important",
                        borderTopWidth: "6px !important"
                    },
                    '&.place-left:after': {
                        borderLeftColor: "#ccc !important",
                        borderLeftStyle: "solid !important",
                        borderLeftWidth: "6px !important"
                    },
                    '&.place-right:after': {
                        borderRightColor: "#ccc !important",
                        borderRightStyle: "solid !important",
                        borderRightWidth: "6px !important"
                    },
                    '&.place-bottom:after': {
                        borderBottomColor: "#ccc !important",
                        borderBottomStyle: "solid !important",
                        borderBottomWidth: "6px !important"
                    }
                }
            });
        }
        return (React.createElement("div", { style: { display: "inline-block" } },
            childrenWithProps,
            React.createElement(ReactTooltip, __assign({ className: classNames('up-tooltip', custom), id: _id, getContent: this.getContent }, others))));
    };
    UpTooltip.defaultProps = {
        content: '',
        place: 'right',
        effect: 'float',
        type: 'light',
        multiline: false,
        html: false,
        delayHide: 500,
        delayShow: 500,
        disable: false
    };
    return UpTooltip;
}(react_1.Component));
exports.default = UpTooltip;
//# sourceMappingURL=UpTooltip.js.map