"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var typestyle_1 = require("typestyle");
var helpers_1 = require("../../../Common/utils/helpers");
var Icons_1 = require("../../Display/Icons/Icons");
var Checkbox = (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.onKeyDown = function (event) {
            if (_this.props.Disable || _this.props.ReadOnly) {
                return;
            }
            if (event.keyCode === 32) {
                _this.onClick(!_this.state.Check);
                event.preventDefault();
            }
            if (!helpers_1.isNullOrUndef(_this.props.onKeyDown)) {
                _this.props.onKeyDown(event);
            }
        };
        _this.onClick = function (event) {
            if (_this.props.Disable || _this.props.ReadOnly) {
                return;
            }
            _this.setState({ Check: !_this.state.Check, }, function () {
                if (!helpers_1.isNullOrUndef(_this.props.onChange)) {
                    _this.props.onChange(_this.state.Check);
                }
            });
        };
        _this.onFocus = function (event) {
            _this.setState({ Focus: true, });
        };
        _this.onBlur = function (event) {
            _this.setState({ Focus: false, });
        };
        _this.focus = function () {
            if (!_this.props.Disable) {
                _this.ref.focus();
            }
        };
        _this.state = {
            Check: _this.props.Check,
            Focus: false,
        };
        return _this;
    }
    Checkbox.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.Check !== this.props.Check && nextProps.Check !== this.state.Check) {
            this.setState({ Check: nextProps.Check, });
        }
    };
    Checkbox.prototype.render = function () {
        var _this = this;
        var couleurCheck = this.state.Check && !this.props.Disable ? "#f59100" : "#d7d7d7";
        var styleG = helpers_1.getFontClassName({ fontSize: "14px", color: "#4e5b59", }) + " " + typestyle_1.style({
            cursor: this.props.Disable || this.props.ReadOnly ? "auto" : "pointer",
            opacity: this.props.Disable ? 0.5 : 1,
            textDecoration: this.state.Focus && !this.props.Disable ? "underline #f59100" : "none",
            $nest: {
                "& > span": {
                    verticalAlign: "middle",
                },
            },
        });
        var styleFocus = typestyle_1.style({
            $nest: {
                "&:focus": {
                    outline: "none",
                },
            },
        });
        var result = React.createElement("span", { className: styleG },
            " ",
            this.props.Text);
        if (this.state.Check) {
            result = React.createElement(Icons_1.IconCheckBox_Check, { Color: couleurCheck, IconSize: "16px", onClick: this.onClick }, result);
        }
        else {
            result = React.createElement(Icons_1.IconCheckBox_Empty, { Color: couleurCheck, IconSize: "16px", onClick: this.onClick }, result);
        }
        return React.createElement("span", { className: styleFocus, tabIndex: this.props.Disable ? null : 0, onFocus: this.onFocus, onBlur: this.onBlur, onKeyDown: this.onKeyDown, ref: function (c) { _this.ref = c; } }, result);
    };
    return Checkbox;
}(React.Component));
exports.default = Checkbox;
//# sourceMappingURL=Checkbox.js.map