"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var helpers_1 = require("../../../Common/utils/helpers");
var Checkbox_1 = require("./Checkbox");
var CheckboxGroup = (function (_super) {
    __extends(CheckboxGroup, _super);
    function CheckboxGroup(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.onKeyDown = function (event) {
            if (_this.props.Disable) {
                return;
            }
            var focusIdx = _this.state.FocusIdx;
            if (event.keyCode === 37 || event.keyCode === 38) {
                focusIdx--;
            }
            else if (event.keyCode === 39 || event.keyCode === 40) {
                focusIdx++;
            }
            else {
                return;
            }
            if (focusIdx < 0) {
                focusIdx = 0;
            }
            if (focusIdx >= _this.props.Values.length) {
                focusIdx = _this.props.Values.length - 1;
            }
            _this.setState({ FocusIdx: focusIdx, });
            event.preventDefault();
        };
        _this.inputTab = [];
        _this.state = {
            ValueIdx: helpers_1.arrayIsNullOrEmpty(_this.props.ValueIdx) ? [] :
                _this.props.ValueIdx.map(function (d, idx) { return d; }),
            FocusIdx: null,
        };
        return _this;
    }
    CheckboxGroup.prototype.onChange = function (valueIdx, check) {
        if (this.props.Disable || this.props.ReadOnly) {
            return;
        }
        if (this.state.ValueIdx.indexOf(valueIdx) >= 0) {
            if (check) {
                this.setState({ FocusIdx: valueIdx, });
            }
            else {
                this.setState({ ValueIdx: this.state.ValueIdx.filter(function (i) { return i !== valueIdx; }), FocusIdx: valueIdx, }, this.propageOnChange);
            }
        }
        else {
            if (check) {
                this.setState({ ValueIdx: this.state.ValueIdx.concat(valueIdx), FocusIdx: valueIdx, }, this.propageOnChange);
            }
            else {
                this.setState({ FocusIdx: valueIdx, });
            }
        }
    };
    CheckboxGroup.prototype.propageOnChange = function () {
        if (!helpers_1.isNullOrUndef(this.props.onChange)) {
            this.props.onChange(this.state.ValueIdx.map(function (d, idx) { return d; }));
        }
    };
    CheckboxGroup.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.ValueIdx !== this.props.ValueIdx && nextProps.ValueIdx !== this.state.ValueIdx) {
            this.setState({ ValueIdx: helpers_1.arrayIsNullOrEmpty(nextProps.ValueIdx) ? [] :
                    nextProps.ValueIdx.map(function (d, idx) { return d; }) });
        }
    };
    CheckboxGroup.prototype.componentDidUpdate = function () {
        if (this.state.FocusIdx !== null) {
            this.inputTab[this.state.FocusIdx].focus();
        }
    };
    CheckboxGroup.prototype.render = function () {
        var _this = this;
        if (helpers_1.arrayIsNullOrEmpty(this.props.Values)) {
            return React.createElement("span", null);
        }
        return React.createElement("span", null, this.props.Values.map(function (value, idx) {
            return React.createElement("span", { key: idx },
                React.createElement(Checkbox_1.default, { Text: value, Check: _this.state.ValueIdx.indexOf(idx) >= 0, Disable: _this.props.Disable, ReadOnly: _this.props.ReadOnly, onChange: function (check) { return _this.onChange(idx, check); }, onKeyDown: _this.onKeyDown, ref: function (c) { _this.inputTab[idx] = c; } }),
                idx === _this.props.Values.length ? null :
                    _this.props.Horizontal ? React.createElement("span", null, "\u2003") : React.createElement("br", null));
        }));
    };
    return CheckboxGroup;
}(React.Component));
exports.default = CheckboxGroup;
//# sourceMappingURL=CheckboxGroup.js.map