/// <reference types="react" />
import * as React from "react";
import { ValidationReturn } from ".";
export interface DateInputProps {
    Value?: Date | string;
    Placeholder?: string;
    Disable?: boolean;
    Label?: string;
    Icon?: JSX.Element;
    InformationText?: string;
    SuccessText?: string;
    ErrorText?: string;
    Width?: string;
    Require?: boolean;
    ReadOnly?: boolean;
    InitialState?: boolean;
    AutoFocus?: boolean;
    Validate?: (value: Date | string) => ValidationReturn;
    onChange?: (value: Date | string) => void;
    onFocus?: (event) => void;
    onBlur?: (value: Date | string) => void;
    onKeyDown?: (event, isAbort?: boolean) => void;
}
export interface DateInputState {
    Success?: boolean;
    Value: Date | string;
    TextCanChange: boolean;
    SpecificMessage: string;
}
export default class DateInput extends React.Component<DateInputProps, DateInputState> {
    private control;
    private _calendar;
    constructor(p: any, c: any);
    private processValidation;
    private incDate;
    private onBlur;
    private onChange;
    private onKeyDown;
    private onCalendarItemClick;
    focus: () => void;
    componentWillReceiveProps(nextProps: any): void;
    render(): JSX.Element;
}
