"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var typestyle_1 = require("typestyle");
var helpers_1 = require("../../../Common/utils/helpers");
var Icons_1 = require("../../Display/Icons/Icons");
var _1 = require(".");
var Calendrier_1 = require("./Calendrier");
var DateInput = (function (_super) {
    __extends(DateInput, _super);
    function DateInput(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.processValidation = function (value, convert, callback) {
            if (typeof value === "string") {
                var dConvert = helpers_1.ConvertToDate(value);
                if (dConvert !== null && convert) {
                    value = dConvert;
                }
            }
            var validation = helpers_1.isNullOrUndef(_this.props.Validate) ? null : _this.props.Validate(dConvert !== null ? dConvert : value);
            if (helpers_1.isNullOrUndef(_this.props.Validate)) {
                _this.setState({ Value: value, Success: _this.props.InitialState, SpecificMessage: null, }, callback);
            }
            else if (helpers_1.isNullOrUndef(validation) || helpers_1.isNullOrUndef(validation.ok)) {
                _this.setState({ Value: value, Success: null, SpecificMessage: null, }, callback);
            }
            else {
                _this.setState({ Value: value, Success: validation.ok, SpecificMessage: validation.specificMessage, }, callback);
            }
        };
        _this.incDate = function (nbJour) {
            if (_this.props.ReadOnly || _this.props.Disable) {
                return;
            }
            if (typeof _this.state.Value === "string") {
                return;
            }
            var saveOldValue = _this.state.Value;
            var valeur = helpers_1.incrementJour(_this.state.Value, nbJour);
            _this.processValidation(valeur, false, function () {
                if ((!helpers_1.isNullOrUndef(_this.props.onChange)) && saveOldValue.toString() !== _this.state.Value.toString()) {
                    _this.props.onChange(_this.state.Value);
                }
            });
        };
        _this.onBlur = function (event) {
            _this.processValidation(event.target.value, true, function () {
                if (!helpers_1.isNullOrUndef(_this.props.onBlur)) {
                    _this.props.onBlur(_this.state.Value);
                }
                _this._calendar.Blur();
            });
        };
        _this.onChange = function (event) {
            var saveOldValue = _this.state.Value;
            _this.processValidation(event.target.value, false, function () {
                if ((!helpers_1.isNullOrUndef(_this.props.onChange)) && saveOldValue !== _this.state.Value) {
                    _this.props.onChange(_this.state.Value);
                }
            });
        };
        _this.onKeyDown = function (event) {
            var abort = false;
            if (!_this.props.Disable && !_this.props.ReadOnly) {
                if (event.keyCode === 38) {
                    _this.incDate(1);
                    abort = true;
                }
                else if (event.keyCode === 40) {
                    _this.incDate(-1);
                    abort = true;
                }
            }
            if (abort) {
                event.preventDefault();
                return;
            }
            if (!_this.state.TextCanChange) {
                if (event.keyCode === 9 || (event.keyCode >= 112 && event.keyCode <= 123)) {
                }
                else {
                    event.preventDefault();
                    abort = true;
                }
            }
            if (!helpers_1.isNullOrUndef(_this.props.onKeyDown)) {
                _this.props.onKeyDown(event, abort);
            }
        };
        _this.onCalendarItemClick = function (date) {
            var saveOldValue = helpers_1.isNullOrUndef(_this.state.Value) ? "" : _this.state.Value;
            _this.processValidation(date, true, function () {
                if ((!helpers_1.isNullOrUndef(_this.props.onChange)) && saveOldValue.toString() !== _this.state.Value.toString()) {
                    _this.props.onChange(_this.state.Value);
                }
            });
        };
        _this.focus = function () {
            if (!_this.props.Disable) {
                _this.control.focus();
            }
        };
        _this.state = {
            Success: helpers_1.isNullOrUndef(_this.props.InitialState) ? null : _this.props.InitialState,
            Value: _this.props.Value,
            TextCanChange: _this.props.ReadOnly !== true,
            SpecificMessage: null,
        };
        return _this;
    }
    DateInput.prototype.componentWillReceiveProps = function (nextProps) {
        var partialState = {};
        if (nextProps.Value !== this.props.Value && nextProps.Value !== this.state.Value) {
            partialState = { Value: nextProps.Value, Success: nextProps.InitialState, SpecificMessage: null, };
        }
        else if (nextProps.InitialState !== this.state.Success) {
            partialState.Success = nextProps.InitialState;
        }
        if (partialState.hasOwnProperty("Success")) {
            this.setState(partialState);
        }
    };
    DateInput.prototype.render = function () {
        var _this = this;
        var couleurs = _1.GetFinanceurColors(this.props.Disable, this.state.Success);
        var styleG = typestyle_1.style({
            width: helpers_1.isNullOrUndef(this.props.Width) ? "250px" : this.props.Width,
            position: "relative",
            display: "inline-block",
            verticalAlign: "top",
            textAlign: "left",
        });
        var styleLabel = helpers_1.getFontClassName({ color: couleurs.Label, fontSize: "14px", });
        var styleRequire = helpers_1.getFontClassName({ color: "red", fontSize: "14px", lineHeight: 1.36, }) + " " + typestyle_1.style({
            position: "absolute",
            top: 0,
            right: 0,
        });
        var styleFontInput = helpers_1.getFontClassName({ color: couleurs.Value, fontSize: "14px", lineHeight: 1.36, });
        var styleInputContainer = typestyle_1.style({
            position: "relative",
            width: "100%",
            display: "inline-block",
            $nest: {
                "& *:focus": {
                    outline: "none",
                },
            },
        });
        var styleInput = typestyle_1.style({
            width: "100%",
            border: "none",
            borderBottom: "1px solid " + couleurs.Border,
            paddingBottom: "6px",
            boxSizing: "border-box",
            paddingLeft: (!helpers_1.isNullOrUndef(this.props.Icon) ? 20 : 0).toString() + "px",
            paddingRight: (28 + (this.props.Require ? 6 : 0)).toString() + "px",
            backgroundColor: "inherit",
            $nest: {
                "&:hover": {
                    borderBottomColor: couleurs.BorderFocus,
                },
                "&:focus": {
                    borderBottomColor: couleurs.BorderFocus,
                },
                "&::placeholder": {
                    color: couleurs.Placeholder,
                    opacity: 0.5,
                }
            },
        });
        var styleIcon = typestyle_1.style({
            position: "absolute",
            top: 0,
            left: 0,
        });
        var styleChevron = typestyle_1.style({
            position: "absolute",
            top: "5%",
            right: (2 + (this.props.Require ? 6 : 0)).toString() + "px",
        });
        var styleIconInfos = typestyle_1.style({
            opacity: this.state.Success === false ? 1 : 0.5,
        });
        var styleFontInfos = helpers_1.getFontClassName({ color: couleurs.Value, fontSize: "12px", lineHeight: 1.58, }) + " " + typestyle_1.style({
            opacity: this.state.Success === false ? 1 : 0.5,
        });
        var styleFontInfosSuc = helpers_1.getFontClassName({ color: couleurs.Border, fontSize: "12px", lineHeight: 1.58, });
        var styleSousLabel = typestyle_1.style({
            textAlign: "justify",
            display: "inline-block",
            width: "100%",
        });
        var texteSup = null;
        if (this.state.Success) {
            var texteSupStr = helpers_1.stringIsNullOrEmpty(this.state.SpecificMessage) ?
                helpers_1.stringIsNullOrEmpty(this.props.SuccessText) ? "" : this.props.SuccessText :
                this.state.SpecificMessage;
            if (texteSupStr != "") {
                texteSup = React.createElement(Icons_1.IconSuccess, { Color: couleurs.Border, BackgroundColor: "", IconSize: "16px" },
                    React.createElement("span", { className: styleFontInfosSuc },
                        " ",
                        texteSupStr));
            }
        }
        else if (this.state.Success !== null) {
            var texteSupStr = helpers_1.stringIsNullOrEmpty(this.state.SpecificMessage) ?
                helpers_1.stringIsNullOrEmpty(this.props.ErrorText) ? "" : this.props.ErrorText :
                this.state.SpecificMessage;
            if (texteSupStr != "") {
                texteSup = React.createElement(Icons_1.IconError, { Color: couleurs.Border, BackgroundColor: "", IconSize: "16px" },
                    React.createElement("span", { className: styleFontInfosSuc },
                        " ",
                        texteSupStr));
            }
        }
        if (texteSup === null && !helpers_1.stringIsNullOrEmpty(this.props.InformationText)) {
            texteSup = React.createElement(Icons_1.IconInfos, { Color: couleurs.Value, BackgroundColor: "", IconSize: "16px", className: styleIconInfos },
                React.createElement("span", { className: styleFontInfos },
                    " ",
                    this.props.InformationText));
        }
        return React.createElement("span", { className: styleG },
            helpers_1.stringIsNullOrEmpty(this.props.Label) ? null :
                React.createElement("span", { className: styleLabel },
                    this.props.Label,
                    React.createElement("br", null)),
            React.createElement("span", { className: styleFontInput + " " + styleInputContainer },
                this.props.Require ? React.createElement("span", { className: styleRequire }, "*") : null,
                helpers_1.isNullOrUndef(this.props.Icon) ? null :
                    React.createElement("span", { className: styleIcon }, this.props.Icon),
                React.createElement("span", { className: styleChevron },
                    React.createElement(Calendrier_1.default, { ref: function (c) { _this._calendar = c; }, Date: typeof this.state.Value === "string" ? null : this.state.Value, onChange: this.onCalendarItemClick })),
                React.createElement("input", { className: styleFontInput + " " + styleInput, disabled: this.props.Disable, autoFocus: this.props.AutoFocus, value: helpers_1.isNullOrUndef(this.state.Value) ? "" : typeof this.state.Value === "string" ? this.state.Value : helpers_1.formatDate(this.state.Value), placeholder: this.props.Placeholder, onFocus: this.props.onFocus, onKeyDown: this.onKeyDown, onBlur: this.onBlur, onChange: this.onChange, ref: function (c) { _this.control = c; } })),
            React.createElement("span", { className: styleSousLabel }, texteSup));
    };
    return DateInput;
}(React.Component));
exports.default = DateInput;
//# sourceMappingURL=DateInput.js.map