"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var typestyle_1 = require("typestyle");
var helpers_1 = require("../../../Common/utils/helpers");
var Radio = (function (_super) {
    __extends(Radio, _super);
    function Radio(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.onKeyDown = function (event) {
            if (_this.props.Disable) {
                return;
            }
            if (event.keyCode === 32) {
                _this.onClick();
                event.preventDefault();
            }
            if (!helpers_1.isNullOrUndef(_this.props.onKeyDown)) {
                _this.props.onKeyDown(event);
            }
        };
        _this.onClick = function () {
            if (_this.props.Disable) {
                return;
            }
            if (_this.state.Check) {
                return;
            }
            _this.setState({ Check: true, }, function () {
                if (!helpers_1.isNullOrUndef(_this.props.onChange)) {
                    _this.props.onChange(_this.state.Check);
                }
            });
        };
        _this.onFocus = function (event) {
            _this.setState({ Focus: true, });
        };
        _this.onBlur = function (event) {
            _this.setState({ Focus: false, });
        };
        _this.focus = function () {
            if (!_this.props.Disable) {
                _this.ref.focus();
            }
        };
        _this.state = {
            Check: _this.props.Check,
            Focus: false,
        };
        return _this;
    }
    Radio.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.Check !== this.props.Check && nextProps.Check !== this.state.Check) {
            this.setState({ Check: nextProps.Check, });
        }
    };
    Radio.prototype.render = function () {
        var _this = this;
        var epaisseurCercle = this.state.Check ? "5" : "2";
        var couleurCercle = this.state.Check && !this.props.Disable ? "f59100" : "d7d7d7";
        var styleG = helpers_1.getFontClassName({ fontSize: "14px", color: "#4e5b59", }) + " " + typestyle_1.style({
            cursor: this.props.Disable ? "auto" : "pointer",
            opacity: this.props.Disable ? 0.5 : 1,
            $nest: {
                "& > span": {
                    verticalAlign: "middle",
                },
                "&:focus": {
                    outline: "none",
                },
            },
        });
        var styleSousligner = typestyle_1.style({
            textDecoration: this.state.Focus && !this.props.Disable ? "underline #f59100" : "none",
        });
        var styleCercle = typestyle_1.style({
            borderRadius: "50%",
            height: "16px",
            width: "16px",
            border: epaisseurCercle + "px solid #" + couleurCercle,
            display: "inline-block",
            boxSizing: "border-box",
        });
        return React.createElement("span", { className: styleG, onClick: this.onClick, onKeyDown: this.onKeyDown, onFocus: this.onFocus, onBlur: this.onBlur, tabIndex: this.props.Disable ? null : 0, ref: function (c) { _this.ref = c; } },
            React.createElement("span", { className: styleCercle }),
            React.createElement("span", { className: styleSousligner },
                " ",
                this.props.Text),
            " ");
    };
    return Radio;
}(React.Component));
exports.default = Radio;
//# sourceMappingURL=Radio.js.map