"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var helpers_1 = require("../../../Common/utils/helpers");
var Radio_1 = require("./Radio");
var RadioGroup = (function (_super) {
    __extends(RadioGroup, _super);
    function RadioGroup(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.onChange = function (valueIdx, check) {
            if (_this.props.Disable) {
                return;
            }
            if (_this.state.ValueIdx !== valueIdx) {
                if (check) {
                    _this.setState({ ValueIdx: valueIdx, FocusIdx: valueIdx, }, _this.propageChange);
                }
                else {
                    _this.setState({ FocusIdx: valueIdx, });
                }
            }
            else {
                if (check) {
                    _this.setState({ FocusIdx: valueIdx, });
                }
                else {
                    _this.setState({ ValueIdx: null, FocusIdx: valueIdx, }, _this.propageChange);
                }
            }
        };
        _this.propageChange = function () {
            if (!helpers_1.isNullOrUndef(_this.props.onChange)) {
                _this.props.onChange(_this.state.ValueIdx);
            }
        };
        _this.onKeyDown = function (event) {
            if (_this.props.Disable) {
                return;
            }
            var valueIdx = _this.state.ValueIdx;
            if (event.keyCode === 37 || event.keyCode === 38) {
                valueIdx--;
            }
            else if (event.keyCode === 39 || event.keyCode === 40) {
                valueIdx++;
            }
            else {
                return;
            }
            if (valueIdx < 0) {
                valueIdx = 0;
            }
            if (valueIdx >= _this.props.Values.length) {
                valueIdx = _this.props.Values.length - 1;
            }
            _this.onChange(valueIdx, true);
            event.preventDefault();
        };
        _this.inputTab = [];
        _this.state = {
            ValueIdx: helpers_1.numberIsNullOrUndef(_this.props.ValueIdx) ? null : _this.props.ValueIdx,
            FocusIdx: null,
        };
        return _this;
    }
    RadioGroup.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.ValueIdx !== this.props.ValueIdx && nextProps.ValueIdx !== this.state.ValueIdx) {
            this.setState({ ValueIdx: helpers_1.numberIsNullOrUndef(nextProps.ValueIdx) ? null : nextProps.ValueIdx, });
        }
    };
    RadioGroup.prototype.componentDidUpdate = function () {
        if (this.state.FocusIdx !== null) {
            this.inputTab[this.state.FocusIdx].focus();
        }
    };
    RadioGroup.prototype.render = function () {
        var _this = this;
        if (helpers_1.arrayIsNullOrEmpty(this.props.Values)) {
            return React.createElement("span", null);
        }
        return React.createElement("span", null, this.props.Values.map(function (value, idx) {
            return React.createElement("span", { key: idx },
                React.createElement(Radio_1.default, { Text: value, Check: _this.state.ValueIdx === idx, Disable: _this.props.Disable, onChange: function (check) { return _this.onChange(idx, check); }, onKeyDown: _this.onKeyDown, ref: function (c) { _this.inputTab[idx] = c; } }),
                idx === _this.props.Values.length ? null :
                    _this.props.Horizontal ? React.createElement("span", null, "\u2003") : React.createElement("br", null));
        }));
    };
    return RadioGroup;
}(React.Component));
exports.default = RadioGroup;
//# sourceMappingURL=RadioGroup.js.map