"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var typestyle_1 = require("typestyle");
var helpers_1 = require("../../../Common/utils/helpers");
var Icons_1 = require("../../Display/Icons/Icons");
var _1 = require(".");
var Tableau = (function (_super) {
    __extends(Tableau, _super);
    function Tableau(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.onOrder = function (idxCol) {
            if (helpers_1.arrayIsNullOrEmpty(_this.state.Order)) {
                _this.setState({ Order: [{ IdxCol: idxCol, Descendant: false, }], });
            }
            else {
                var order = _this.state.Order.map(function (item) { return __assign({}, item); });
                if (order[0].IdxCol === idxCol) {
                    order[0].Descendant = !order[0].Descendant;
                }
                else {
                    order = order.filter(function (item, idx) {
                        return item && item.IdxCol !== idxCol;
                    });
                    order.splice(0, 0, { IdxCol: idxCol, Descendant: false, });
                }
                _this.setState({ Order: order.map(function (item) { return __assign({}, item); }), });
            }
        };
        _this.onSearchChange = function (value) {
            if (value !== _this.state.SearchText) {
                _this.setState({ SearchText: value, });
            }
        };
        _this.applyOrder = function (donnees, order) {
            if (helpers_1.arrayIsNullOrEmpty(donnees)) {
                return [];
            }
            if (!_this.props.OrderActif || helpers_1.arrayIsNullOrEmpty(order) || helpers_1.arrayIsNullOrEmpty(_this.props.EnTetes) || donnees.length < 2) {
                return donnees;
            }
            var orderToApply = order.filter(function (item) {
                return _this.props.EnTetes[item.IdxCol] && _this.props.EnTetes[item.IdxCol].OrderActif !== false;
            });
            if (helpers_1.arrayIsNullOrEmpty(orderToApply)) {
                return donnees;
            }
            var result = [donnees[0]];
            for (var cptDonnees = 1; cptDonnees < donnees.length; cptDonnees++) {
                var insert = false;
                for (var cptResult = 0; cptResult < result.length; cptResult++) {
                    for (var cptOrdre = 0; cptOrdre < orderToApply.length; cptOrdre++) {
                        var dataDonnees = donnees[cptDonnees][orderToApply[cptOrdre].IdxCol];
                        var dataResult = result[cptResult][orderToApply[cptOrdre].IdxCol];
                        if (!helpers_1.isNullOrUndef(_this.props.EnTetes[orderToApply[cptOrdre].IdxCol].OrderCompare)) {
                            var comp = _this.props.EnTetes[orderToApply[cptOrdre].IdxCol].OrderCompare(dataDonnees, dataResult);
                            if (comp === 0) {
                                continue;
                            }
                            if ((orderToApply[cptOrdre].Descendant && comp > 0)
                                || (!orderToApply[cptOrdre].Descendant && comp < 0)) {
                                result.splice(cptResult, 0, donnees[cptDonnees]);
                                insert = true;
                            }
                            break;
                        }
                        if (dataDonnees === null) {
                            break;
                        }
                        if (dataResult === null) {
                            result.splice(cptResult, 0, donnees[cptDonnees]);
                            insert = true;
                            break;
                        }
                        if (typeof dataDonnees === "object" || typeof dataResult === "object" || dataDonnees == dataResult) {
                            continue;
                        }
                        if ((orderToApply[cptOrdre].Descendant && dataDonnees > dataResult)
                            || (!orderToApply[cptOrdre].Descendant && dataDonnees < dataResult)) {
                            result.splice(cptResult, 0, donnees[cptDonnees]);
                            insert = true;
                        }
                        break;
                    }
                    if (insert) {
                        break;
                    }
                }
                if (!insert) {
                    result.push(donnees[cptDonnees]);
                }
            }
            return result;
        };
        _this.applySearch = function (donnees, search) {
            if (helpers_1.arrayIsNullOrEmpty(donnees)) {
                return [];
            }
            if (!_this.props.RechercheVisible || helpers_1.stringIsNullOrEmpty(search) || helpers_1.arrayIsNullOrEmpty(_this.props.EnTetes) || donnees.length < 2) {
                return donnees;
            }
            var filtre = function (ligne, idx) {
                if (helpers_1.arrayIsNullOrEmpty(ligne)) {
                    return false;
                }
                for (var cpt = 0; cpt < ligne.length; cpt++) {
                    if (_this.props.EnTetes[cpt] && _this.props.EnTetes[cpt].RechercheActif !== false && helpers_1.objectContains(ligne[cpt], search)) {
                        return true;
                    }
                }
                return false;
            };
            return donnees.filter(filtre).concat(donnees.filter(function (l, i) { return !filtre(l, i); }));
        };
        _this.state = {
            Donnees: _this.props.Donnees.map(function (ligne) {
                return ligne.map(function (cell) {
                    return cell;
                });
            }),
            Order: [],
            SearchText: null,
        };
        return _this;
    }
    Tableau.prototype.componentWillReceiveProps = function (nextProps) {
        if (!helpers_1.arrayIsIdentical(nextProps.Donnees, this.props.Donnees) && !helpers_1.arrayIsIdentical(nextProps.Donnees, this.state.Donnees)) {
            this.setState({
                Donnees: nextProps.Donnees.map(function (ligne) {
                    return ligne.map(function (cell) {
                        return cell;
                    });
                }),
            });
        }
    };
    Tableau.prototype.render = function () {
        var _this = this;
        var backColor = "#ffffff";
        var colorEnTete = "#9b9b9b";
        var enTetes = !helpers_1.arrayIsNullOrEmpty(this.props.EnTetes);
        var styleG = typestyle_1.style({
            backgroundColor: backColor,
            width: "100%",
            position: "relative",
        });
        var styleTitre = helpers_1.getFontClassName({ fontSize: "18px", fontWeight: 500, color: "#4e5b59", });
        var styleRecherche = typestyle_1.style({
            textAlign: "right",
            marginBottom: "0px",
        });
        var styleTable = helpers_1.getFontClassName({ fontSize: "14px", color: "#4a4a4a", }) + " " + typestyle_1.style({
            width: "100%",
            $nest: {
                "& tr": {
                    width: "100%",
                },
                "& td": {
                    minHeight: "32px",
                    verticalAlign: "middle",
                    padding: "5px 8px 5px 5px",
                },
                "& tr:nth-child(2n)": {
                    backgroundColor: enTetes ? "#f5f5f5" : backColor,
                },
                "& tr:nth-child(2n+1)": {
                    backgroundColor: enTetes ? backColor : "#f5f5f5",
                },
            },
        });
        var styleEnTete = helpers_1.getFontClassName({ fontSize: "12px", fontWeight: 500, color: colorEnTete, }) + " " + typestyle_1.style({
            $nest: {
                "& td": {
                    height: "24px",
                    paddingBottom: "4px",
                },
            },
        });
        var donnees = this.applySearch(this.applyOrder(this.state.Donnees, this.state.Order), this.state.SearchText);
        return React.createElement("div", { className: styleG },
            helpers_1.stringIsNullOrEmpty(this.props.Titre) ? null :
                React.createElement("p", { className: styleTitre }, this.props.Titre),
            !this.props.RechercheVisible ? null :
                React.createElement("p", { className: styleRecherche },
                    React.createElement(_1.TextInput, { Placeholder: "Recherche", Icon: React.createElement(Icons_1.IconRecherche, { Color: "#354052", BackgroundColor: "", IconSize: "14px" }), IconPos: _1.PosIconEnum.Droite, onChange: this.onSearchChange })),
            React.createElement("table", { className: styleTable },
                React.createElement("tbody", null,
                    !enTetes ? null :
                        React.createElement("tr", { className: styleEnTete }, this.props.EnTetes.map(function (enTete, idx) {
                            var icon = null;
                            if (_this.props.OrderActif && !helpers_1.isNullOrUndef(enTete) && enTete.OrderActif !== false) {
                                var direction = Icons_1.DirectionEnum.Bas;
                                if (!helpers_1.arrayIsNullOrEmpty(_this.state.Order)) {
                                    var ordre = _this.state.Order.filter(function (item) { return item.IdxCol === idx; });
                                    if (ordre && ordre[0] && ordre[0].Descendant) {
                                        direction = Icons_1.DirectionEnum.Haut;
                                    }
                                }
                                icon = React.createElement(Icons_1.IconChevron, { Color: colorEnTete, IconSize: "12px", fontWeight: 500, onClick: function () { return _this.onOrder(idx); }, Direction: direction });
                            }
                            return helpers_1.isNullOrUndef(enTete) ? React.createElement("td", { key: idx }) :
                                React.createElement("td", { key: idx },
                                    React.createElement("span", null, enTete.Libelle),
                                    "\u00A0",
                                    icon);
                        })),
                    donnees.map(function (ligne, idx) {
                        if (helpers_1.arrayIsNullOrEmpty(ligne)) {
                            return null;
                        }
                        return React.createElement("tr", { key: idx }, ligne.map(function (cellule, idx2) {
                            return React.createElement("td", { key: idx.toString() + "_" + idx2.toString() }, cellule);
                        }));
                    }))));
    };
    return Tableau;
}(React.Component));
exports.default = Tableau;
//# sourceMappingURL=Tableau.js.map