"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var typestyle_1 = require("typestyle");
var helpers_1 = require("../../../Common/utils/helpers");
var Icons_1 = require("../../Display/Icons/Icons");
var _1 = require(".");
var TextArea = (function (_super) {
    __extends(TextArea, _super);
    function TextArea(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.processValidation = function (value) {
            var validation = helpers_1.isNullOrUndef(_this.props.Validate) ? null : _this.props.Validate(value);
            if (helpers_1.isNullOrUndef(validation) || helpers_1.isNullOrUndef(validation.ok)) {
                _this.setState({ Text: value, Success: null, SpecificMessage: null, });
            }
            else {
                _this.setState({ Text: value, Success: validation.ok, SpecificMessage: validation.specificMessage, });
            }
        };
        _this.onChange = function (event) {
            var saveOldValue = _this.state.Text;
            _this.processValidation(event.target.value);
            if ((!helpers_1.isNullOrUndef(_this.props.onChange)) && saveOldValue !== event.target.value) {
                _this.props.onChange(event.target.value);
            }
        };
        _this.onBlur = function (event) {
            _this.processValidation(event.target.value);
            if (!helpers_1.isNullOrUndef(_this.props.onBlur)) {
                _this.props.onBlur(event);
            }
        };
        _this.state = {
            Text: _this.props.Value,
            Success: helpers_1.isNullOrUndef(_this.props.InitialState) ? null : _this.props.InitialState,
            SpecificMessage: null,
        };
        return _this;
    }
    TextArea.prototype.componentWillReceiveProps = function (nextProps) {
        var partialState = {};
        if (nextProps.Value !== this.props.Value && nextProps.Value !== this.state.Text) {
            partialState = { Text: nextProps.Value, Success: null, SpecificMessage: null, };
        }
        if (nextProps.InitialState !== this.props.InitialState && nextProps.InitialState !== this.state.Success) {
            partialState = { Success: helpers_1.isNullOrUndef(nextProps.InitialState) ? null : nextProps.InitialState, };
        }
        if (partialState.hasOwnProperty("Success")) {
            this.setState(partialState);
        }
    };
    TextArea.prototype.render = function () {
        var couleurs = _1.GetFinanceurColors(this.props.Disable, this.state.Success);
        var styleG = typestyle_1.style({
            width: helpers_1.isNullOrUndef(this.props.Width) ? "250px" : this.props.Width,
            position: "relative",
            display: "inline-block",
            verticalAlign: "top",
            textAlign: "left",
        });
        var styleLabel = helpers_1.getFontClassName({ color: couleurs.Label, fontSize: "14px", });
        var styleRequire = helpers_1.getFontClassName({ color: "red", fontSize: "14px", lineHeight: 1.36, }) + " " + typestyle_1.style({
            position: "absolute",
            top: "2px",
            left: "4px",
        });
        var styleContainer = typestyle_1.style({
            position: "relative",
            width: "100%",
            display: "inline-block",
        });
        var styleArea = helpers_1.getFontClassName({ fontSize: "14px", lineHeight: 1.36, color: couleurs.Value, }) + " " + typestyle_1.style({
            border: "1px solid " + couleurs.Border,
            background: this.props.Disable ? "#f2f2f2" : "#ffffff",
            padding: "8px",
            boxSizing: "border-box",
            width: helpers_1.isNullOrUndef(this.props.Width) ? "250px" : this.props.Width,
            height: helpers_1.isNullOrUndef(this.props.Height) ? "95px" : this.props.Height,
            $nest: {
                "&::placeholder": {
                    color: couleurs.Placeholder,
                    opacity: this.props.Disable ? 0.25 : 0.5,
                },
                "&:focus": {
                    outline: "none",
                    borderColor: couleurs.BorderFocus,
                },
                "&:hover": {
                    borderColor: couleurs.BorderFocus,
                },
            },
        });
        var styleIconInfos = typestyle_1.style({
            opacity: 0.5,
        });
        var styleFontInfos = helpers_1.getFontClassName({ color: couleurs.Value, fontSize: "12px", lineHeight: 1.58, }) + " " + typestyle_1.style({
            opacity: 0.5,
        });
        var styleFontInfosSuc = helpers_1.getFontClassName({ color: couleurs.Border, fontSize: "12px", lineHeight: 1.58, });
        var styleSousLabel = typestyle_1.style({
            width: "100%",
            textAlign: "justify",
            display: "inline-block",
        });
        var texteSup = null;
        if (this.state.Success) {
            var texteSupStr = helpers_1.stringIsNullOrEmpty(this.state.SpecificMessage) ?
                helpers_1.stringIsNullOrEmpty(this.props.SuccessText) ? "" : this.props.SuccessText :
                this.state.SpecificMessage;
            if (texteSupStr != "") {
                texteSup = React.createElement(Icons_1.IconSuccess, { Color: couleurs.Border, BackgroundColor: "", IconSize: "16px" },
                    React.createElement("span", { className: styleFontInfosSuc },
                        " ",
                        texteSupStr));
            }
        }
        else if (this.state.Success !== null) {
            var texteSupStr = helpers_1.stringIsNullOrEmpty(this.state.SpecificMessage) ?
                helpers_1.stringIsNullOrEmpty(this.props.ErrorText) ? "" : this.props.ErrorText :
                this.state.SpecificMessage;
            if (texteSupStr != "") {
                texteSup = React.createElement(Icons_1.IconError, { Color: couleurs.Border, BackgroundColor: "", IconSize: "16px" },
                    React.createElement("span", { className: styleFontInfosSuc },
                        " ",
                        texteSupStr));
            }
        }
        if (texteSup === null && !helpers_1.stringIsNullOrEmpty(this.props.InformationText)) {
            texteSup = React.createElement(Icons_1.IconInfos, { Color: couleurs.Value, BackgroundColor: "", IconSize: "16px", className: styleIconInfos },
                React.createElement("span", { className: styleFontInfos },
                    " ",
                    this.props.InformationText));
        }
        return React.createElement("span", { className: styleG },
            helpers_1.stringIsNullOrEmpty(this.props.Label) ? null :
                React.createElement("span", { className: styleLabel },
                    this.props.Label,
                    React.createElement("br", null)),
            React.createElement("span", { className: styleContainer },
                this.props.Require ? React.createElement("span", { className: styleRequire }, "*") : null,
                React.createElement("textarea", { className: styleArea, placeholder: this.props.Placeholder, value: helpers_1.isNullOrUndef(this.state.Text) ? "" : this.state.Text, disabled: this.props.Disable, readOnly: this.props.ReadOnly, autoFocus: this.props.AutoFocus, onChange: this.onChange, onBlur: this.onBlur, onFocus: this.props.onFocus, onKeyDown: this.props.onKeyDown })),
            React.createElement("span", { className: styleSousLabel }, texteSup));
    };
    return TextArea;
}(React.Component));
exports.default = TextArea;
//# sourceMappingURL=TextArea.js.map