/// <reference types="react" />
import * as React from "react";
import { ValidationReturn } from ".";
export declare enum PosIconEnum {
    Gauche = 0,
    Droite = 1,
}
export declare enum InputTypeEnum {
    Text = 0,
    Password = 1,
    ComboBox = 2,
    Number = 3,
}
export interface TextInputProps {
    Value?: string;
    Placeholder?: string;
    Disable?: boolean;
    Label?: string;
    Icon?: JSX.Element;
    IconPos?: PosIconEnum;
    InformationText?: string;
    SuccessText?: string;
    ErrorText?: string;
    Width?: string;
    Require?: boolean;
    ReadOnly?: boolean;
    InitialState?: boolean;
    Type?: InputTypeEnum;
    ComboItems?: string[];
    ComboItemSelectIdx?: number;
    NumberMax?: number;
    NumberMin?: number;
    AutoFocus?: boolean;
    Validate?: (value: string) => ValidationReturn;
    onChange?: (value: string) => void;
    onFocus?: (event) => void;
    onBlur?: (event) => void;
    onKeyDown?: (event, isAbort?: boolean) => void;
    onComboItemSelect?: (idx: number) => void;
}
export interface TextInputState {
    Success?: boolean;
    Value: string;
    TextCanChange: boolean;
    IconAGauche: boolean;
    ComboOuverte: boolean;
    SpecificMessage: string;
}
export default class TextInput extends React.Component<TextInputProps, TextInputState> {
    private control;
    constructor(p: any, c: any);
    private processValidation;
    private doNumberDown;
    private doNumberUp;
    private onBlur;
    private onChange;
    private onKeyDown;
    private onChevronClick;
    private onChevron2Click;
    private onChevronBlur;
    private onComboItemClick;
    focus: () => void;
    componentWillReceiveProps(nextProps: any): void;
    render(): JSX.Element;
}
