"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var typestyle_1 = require("typestyle");
var helpers_1 = require("../../../Common/utils/helpers");
var Icons_1 = require("../../Display/Icons/Icons");
var _1 = require(".");
var PosIconEnum;
(function (PosIconEnum) {
    PosIconEnum[PosIconEnum["Gauche"] = 0] = "Gauche";
    PosIconEnum[PosIconEnum["Droite"] = 1] = "Droite";
})(PosIconEnum = exports.PosIconEnum || (exports.PosIconEnum = {}));
var InputTypeEnum;
(function (InputTypeEnum) {
    InputTypeEnum[InputTypeEnum["Text"] = 0] = "Text";
    InputTypeEnum[InputTypeEnum["Password"] = 1] = "Password";
    InputTypeEnum[InputTypeEnum["ComboBox"] = 2] = "ComboBox";
    InputTypeEnum[InputTypeEnum["Number"] = 3] = "Number";
})(InputTypeEnum = exports.InputTypeEnum || (exports.InputTypeEnum = {}));
var TextInput = (function (_super) {
    __extends(TextInput, _super);
    function TextInput(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.processValidation = function (value) {
            var validation = helpers_1.isNullOrUndef(_this.props.Validate) ? null : _this.props.Validate(value);
            if (helpers_1.isNullOrUndef(_this.props.Validate)) {
                _this.setState({ Value: value, Success: _this.props.InitialState, SpecificMessage: null, });
            }
            else if (helpers_1.isNullOrUndef(validation) || helpers_1.isNullOrUndef(validation.ok)) {
                _this.setState({ Value: value, Success: null, SpecificMessage: null, });
            }
            else {
                _this.setState({ Value: value, Success: validation.ok, SpecificMessage: validation.specificMessage, });
            }
        };
        _this.doNumberDown = function () {
            if (_this.props.ReadOnly || _this.props.Disable) {
                return;
            }
            var saveOldValue = _this.state.Value;
            var valeur = helpers_1.stringIsNullOrEmpty(_this.state.Value) ? -1 : (Number(_this.state.Value) - 1);
            if (helpers_1.isNullOrUndef(_this.props.NumberMax) === false && _this.props.NumberMax < Number(valeur)) {
                valeur = _this.props.NumberMax;
            }
            else if (helpers_1.isNullOrUndef(_this.props.NumberMin) === false && _this.props.NumberMin > Number(valeur)) {
                valeur = _this.props.NumberMin;
            }
            _this.processValidation(valeur.toString());
            if ((!helpers_1.isNullOrUndef(_this.props.onChange)) && saveOldValue !== valeur.toString()) {
                _this.props.onChange(valeur.toString());
            }
        };
        _this.doNumberUp = function () {
            if (_this.props.ReadOnly || _this.props.Disable) {
                return;
            }
            var saveOldValue = _this.state.Value;
            var valeur = helpers_1.stringIsNullOrEmpty(_this.state.Value) ? 1 : (Number(_this.state.Value) + 1);
            if (helpers_1.isNullOrUndef(_this.props.NumberMax) === false && _this.props.NumberMax < Number(valeur)) {
                valeur = _this.props.NumberMax;
            }
            else if (helpers_1.isNullOrUndef(_this.props.NumberMin) === false && _this.props.NumberMin > Number(valeur)) {
                valeur = _this.props.NumberMin;
            }
            _this.processValidation(valeur.toString());
            if ((!helpers_1.isNullOrUndef(_this.props.onChange)) && saveOldValue !== valeur.toString()) {
                _this.props.onChange(valeur.toString());
            }
        };
        _this.onBlur = function (event) {
            _this.processValidation(event.target.value);
            if (!helpers_1.isNullOrUndef(_this.props.onBlur)) {
                _this.props.onBlur(event);
            }
        };
        _this.onChange = function (event) {
            if (_this.props.Type === InputTypeEnum.Number) {
                if (helpers_1.numberIsNullOrUndef(Number(event.target.value))
                    || Number(event.target.value) < _this.props.NumberMin || Number(event.target.value) > _this.props.NumberMax) {
                    event.preventDefault();
                    return false;
                }
            }
            var saveOldValue = _this.state.Value;
            _this.processValidation(event.target.value);
            if ((!helpers_1.isNullOrUndef(_this.props.onChange)) && saveOldValue !== event.target.value) {
                _this.props.onChange(event.target.value);
            }
        };
        _this.onKeyDown = function (event) {
            var abort = false;
            if (!_this.props.Disable && !_this.props.ReadOnly) {
                if (_this.props.Type === InputTypeEnum.ComboBox && !helpers_1.arrayIsNullOrEmpty(_this.props.ComboItems)) {
                    if (event.keyCode === 38) {
                        var current = _this.props.ComboItems.indexOf(_this.state.Value);
                        if (current > 0) {
                            _this.onComboItemClick(current - 1);
                            abort = true;
                        }
                    }
                    else if (event.keyCode === 40) {
                        var current = _this.props.ComboItems.indexOf(_this.state.Value);
                        if (current < _this.props.ComboItems.length - 1) {
                            _this.onComboItemClick(current + 1);
                            abort = true;
                        }
                    }
                }
                else if (_this.props.Type === InputTypeEnum.Number) {
                    if (event.keyCode === 38) {
                        _this.doNumberUp();
                        abort = true;
                    }
                    else if (event.keyCode === 40) {
                        _this.doNumberDown();
                        abort = true;
                    }
                }
            }
            if (abort) {
                event.preventDefault();
                return;
            }
            if (!_this.state.TextCanChange) {
                if (event.keyCode === 9 || (event.keyCode >= 112 && event.keyCode <= 123)) {
                }
                else {
                    event.preventDefault();
                    abort = true;
                }
            }
            if (!helpers_1.isNullOrUndef(_this.props.onKeyDown)) {
                _this.props.onKeyDown(event, abort);
            }
        };
        _this.onChevronClick = function (event) {
            if (_this.props.Type === InputTypeEnum.ComboBox) {
                _this.setState({ ComboOuverte: true, });
            }
            else {
                _this.doNumberDown();
            }
        };
        _this.onChevron2Click = function (event) {
            _this.doNumberUp();
        };
        _this.onChevronBlur = function (event) {
            if (_this.props.Type === InputTypeEnum.ComboBox) {
                _this.setState({ ComboOuverte: false, });
            }
        };
        _this.onComboItemClick = function (idx) {
            var saveOldValue = _this.state.Value;
            _this.processValidation(_this.props.ComboItems[idx]);
            if (!helpers_1.isNullOrUndef(_this.props.onComboItemSelect)) {
                _this.props.onComboItemSelect(idx);
            }
            if ((!helpers_1.isNullOrUndef(_this.props.onChange)) && saveOldValue !== _this.props.ComboItems[idx]) {
                _this.props.onChange(_this.props.ComboItems[idx]);
            }
        };
        _this.focus = function () {
            if (!_this.props.Disable) {
                _this.control.focus();
            }
        };
        var ValueIdxInvalide = helpers_1.numberIsNullOrUndef(_this.props.ComboItemSelectIdx) || _this.props.ComboItemSelectIdx < 0
            || helpers_1.isNullOrUndef(_this.props.ComboItems) || _this.props.ComboItemSelectIdx >= _this.props.ComboItems.length;
        var valeur = _this.props.Type === InputTypeEnum.ComboBox && ValueIdxInvalide === false ?
            _this.props.ComboItems[_this.props.ComboItemSelectIdx] :
            _this.props.Value;
        if (_this.props.Type === InputTypeEnum.Number) {
            if (helpers_1.stringIsNullOrEmpty(valeur) || helpers_1.numberIsNullOrUndef(Number(valeur))) {
                valeur = "";
            }
            else if (helpers_1.isNullOrUndef(_this.props.NumberMax) === false && _this.props.NumberMax < Number(valeur)) {
                valeur = _this.props.NumberMax.toString();
            }
            else if (helpers_1.isNullOrUndef(_this.props.NumberMin) === false && _this.props.NumberMin > Number(valeur)) {
                valeur = _this.props.NumberMin.toString();
            }
        }
        _this.state = {
            Success: helpers_1.isNullOrUndef(_this.props.InitialState) ? null : _this.props.InitialState,
            Value: valeur,
            TextCanChange: _this.props.Type !== InputTypeEnum.ComboBox && _this.props.ReadOnly !== true,
            IconAGauche: _this.props.Type === InputTypeEnum.ComboBox || _this.props.Type === InputTypeEnum.Number ? true :
                helpers_1.isNullOrUndef(_this.props.IconPos) || _this.props.IconPos === PosIconEnum.Gauche,
            ComboOuverte: false,
            SpecificMessage: null,
        };
        return _this;
    }
    TextInput.prototype.componentWillReceiveProps = function (nextProps) {
        var partialState = {};
        if (nextProps.Value !== this.props.Value && nextProps.Value !== this.state.Value) {
            switch (nextProps.type) {
                case InputTypeEnum.ComboBox:
                    break;
                case InputTypeEnum.Number:
                    var valeur = nextProps.Value;
                    if (helpers_1.stringIsNullOrEmpty(valeur) || helpers_1.numberIsNullOrUndef(Number(valeur))) {
                        valeur = "";
                    }
                    else if (helpers_1.isNullOrUndef(this.props.NumberMax) === false && this.props.NumberMax < Number(valeur)) {
                        valeur = this.props.NumberMax.toString();
                    }
                    else if (helpers_1.isNullOrUndef(this.props.NumberMin) === false && this.props.NumberMin > Number(valeur)) {
                        valeur = this.props.NumberMin.toString();
                    }
                    partialState = { Value: valeur, Success: nextProps.InitialState, SpecificMessage: null, };
                    break;
                default:
                    partialState = { Value: nextProps.Value, Success: nextProps.InitialState, SpecificMessage: null, };
                    break;
            }
        }
        if (nextProps.InitialState !== this.state.Success) {
            partialState.Success = nextProps.InitialState;
        }
        if (partialState.hasOwnProperty("Success")) {
            this.setState(partialState);
        }
    };
    TextInput.prototype.render = function () {
        var _this = this;
        var chevronPresent = this.props.Type === InputTypeEnum.ComboBox || this.props.Type === InputTypeEnum.Number;
        var chevron2Present = this.props.Type === InputTypeEnum.Number;
        var droiteChevron = this.props.Type === InputTypeEnum.ComboBox ? 8 : 2;
        var couleurs = _1.GetFinanceurColors(this.props.Disable, this.state.Success);
        var styleG = typestyle_1.style({
            width: helpers_1.isNullOrUndef(this.props.Width) ? "250px" : this.props.Width,
            position: "relative",
            display: "inline-block",
            verticalAlign: "top",
            textAlign: "left",
        });
        var styleLabel = helpers_1.getFontClassName({ color: couleurs.Label, fontSize: "14px", });
        var styleRequire = helpers_1.getFontClassName({ color: "red", fontSize: "14px", lineHeight: 1.36, }) + " " + typestyle_1.style({
            position: "absolute",
            top: 0,
            right: 0,
        });
        var styleFontInput = helpers_1.getFontClassName({ color: couleurs.Value, fontSize: "14px", lineHeight: 1.36, });
        var styleInputContainer = typestyle_1.style({
            position: "relative",
            width: "100%",
            display: "inline-block",
            $nest: {
                "& *:focus": {
                    outline: "none",
                },
            },
        });
        var styleInput = typestyle_1.style({
            width: "100%",
            border: "none",
            borderBottom: "1px solid " + couleurs.Border,
            paddingBottom: "6px",
            boxSizing: "border-box",
            paddingLeft: (this.state.IconAGauche && helpers_1.isNullOrUndef(this.props.Icon) === false ? 20 : 0).toString() + "px",
            paddingRight: ((this.state.IconAGauche && (chevronPresent === false) ? 8 : 28) + (this.props.Require ? 6 : 0)).toString() + "px",
            backgroundColor: "inherit",
            $nest: {
                "&:hover": {
                    borderBottomColor: couleurs.BorderFocus,
                },
                "&:focus": {
                    borderBottomColor: couleurs.BorderFocus,
                },
                "&::placeholder": {
                    color: couleurs.Placeholder,
                    opacity: 0.5,
                }
            },
        });
        var styleIcon = typestyle_1.style({
            position: "absolute",
            top: 0,
            left: this.state.IconAGauche ? "0px" : "",
            right: this.state.IconAGauche ? "" : (this.props.Require ? "14px" : "8px"),
        });
        var styleChevron = typestyle_1.style({
            position: "absolute",
            top: this.props.Type === InputTypeEnum.Number ? "40%" : "20%",
            right: (droiteChevron + (this.props.Require ? 6 : 0)).toString() + "px",
        });
        var styleChevron2 = typestyle_1.style({
            position: "absolute",
            top: "0",
            right: (droiteChevron + (this.props.Require ? 6 : 0)).toString() + "px",
        });
        var styleIconInfos = typestyle_1.style({
            opacity: this.state.Success === false ? 1 : 0.5,
        });
        var styleFontInfos = helpers_1.getFontClassName({ color: couleurs.Value, fontSize: "12px", lineHeight: 1.58, }) + " " + typestyle_1.style({
            opacity: this.state.Success === false ? 1 : 0.5,
        });
        var styleFontInfosSuc = helpers_1.getFontClassName({ color: couleurs.Border, fontSize: "12px", lineHeight: 1.58, });
        var styleSousLabel = typestyle_1.style({
            textAlign: "justify",
            display: "inline-block",
            width: "100%",
        });
        var styleCombo = typestyle_1.style({
            position: "absolute",
            top: "100%",
            right: 0,
            left: 0,
            maxHeight: "250px",
            overflow: "auto",
            padding: "10px 10px 0px",
            zIndex: 9998,
            backgroundColor: "#ffffff",
            borderRadius: "0 0 4px 4px",
            border: "1px solid " + couleurs.BorderDefault,
            borderTop: "none",
        });
        var styleLigneCombo = helpers_1.getFontClassName({ color: couleurs.ValueDefault, fontSize: "14px", lineHeight: 1.36, }) + " " + typestyle_1.style({
            minHeight: "19px",
            cursor: "pointer",
        });
        var type = this.props.Type === InputTypeEnum.Password ? "password" : "";
        var texteSup = null;
        if (this.state.Success) {
            var texteSupStr = helpers_1.stringIsNullOrEmpty(this.state.SpecificMessage) ?
                helpers_1.stringIsNullOrEmpty(this.props.SuccessText) ? "" : this.props.SuccessText :
                this.state.SpecificMessage;
            if (texteSupStr != "") {
                texteSup = React.createElement(Icons_1.IconSuccess, { Color: couleurs.Border, BackgroundColor: "", IconSize: "16px" },
                    React.createElement("span", { className: styleFontInfosSuc },
                        " ",
                        texteSupStr));
            }
        }
        else if (this.state.Success !== null) {
            var texteSupStr = helpers_1.stringIsNullOrEmpty(this.state.SpecificMessage) ?
                helpers_1.stringIsNullOrEmpty(this.props.ErrorText) ? "" : this.props.ErrorText :
                this.state.SpecificMessage;
            if (texteSupStr != "") {
                texteSup = React.createElement(Icons_1.IconError, { Color: couleurs.Border, BackgroundColor: "", IconSize: "16px" },
                    React.createElement("span", { className: styleFontInfosSuc },
                        " ",
                        texteSupStr));
            }
        }
        if (texteSup === null && !helpers_1.stringIsNullOrEmpty(this.props.InformationText)) {
            texteSup = React.createElement(Icons_1.IconInfos, { Color: couleurs.Value, BackgroundColor: "", IconSize: "16px", className: styleIconInfos },
                React.createElement("span", { className: styleFontInfos },
                    " ",
                    this.props.InformationText));
        }
        return React.createElement("span", { className: styleG },
            helpers_1.stringIsNullOrEmpty(this.props.Label) ? null :
                React.createElement("span", { className: styleLabel },
                    this.props.Label,
                    React.createElement("br", null)),
            React.createElement("span", { className: styleFontInput + " " + styleInputContainer },
                this.props.Require ? React.createElement("span", { className: styleRequire }, "*") : null,
                helpers_1.isNullOrUndef(this.props.Icon) ? null :
                    React.createElement("span", { className: styleIcon }, this.props.Icon),
                chevronPresent === false ? null :
                    React.createElement(Icons_1.IconChevron, { Direction: Icons_1.DirectionEnum.Bas, Color: couleurs.Chevron, IconSize: "14px", BackgroundColor: "", onClick: this.props.Disable ? null : this.onChevronClick, onBlur: this.onChevronBlur, tabIndex: -1, className: styleChevron }),
                chevron2Present === false ? null :
                    React.createElement(Icons_1.IconChevron, { Direction: Icons_1.DirectionEnum.Haut, Color: couleurs.Chevron, IconSize: "14px", BackgroundColor: "", onClick: this.props.Disable ? null : this.onChevron2Click, className: styleChevron2 }),
                React.createElement("input", { className: styleFontInput + " " + styleInput, disabled: this.props.Disable, type: type, autoFocus: this.props.AutoFocus, value: helpers_1.isNullOrUndef(this.state.Value) ? "" : this.state.Value, placeholder: this.props.Placeholder, onFocus: this.props.onFocus, onKeyDown: this.onKeyDown, onBlur: this.onBlur, onChange: this.onChange, ref: function (c) { _this.control = c; } }),
                this.state.ComboOuverte === false ? null :
                    React.createElement("span", { className: styleCombo }, helpers_1.isNullOrUndef(this.props.ComboItems) ? null :
                        this.props.ComboItems.map(function (value, idx) {
                            return React.createElement("p", { key: idx, onMouseDown: function () { return _this.onComboItemClick(idx); }, className: styleLigneCombo, tabIndex: -1 }, helpers_1.stringIsNullOrEmpty(value) ? "..." : value);
                        }))),
            React.createElement("span", { className: styleSousLabel }, texteSup));
    };
    return TextInput;
}(React.Component));
exports.default = TextInput;
//# sourceMappingURL=TextInput.js.map