"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("@storybook/react");
var TextInput_1 = require("./TextInput");
var Button_1 = require("./Button");
var TextArea_1 = require("./TextArea");
function InputValidateFalse(texte) {
    return { ok: false };
}
function InputValidateTrue(texte) {
    return { ok: true };
}
function InputpasswordChange(texte) {
    alert("Nouvelle valeur : " + texte);
}
function InputpasswordValidate(texte) {
    var regexResult = /^(?=.*\d)(?=.*[A-Z])(?=.*[a-z])(?=.*[^\w\d\s:])([^\s]){8,16}$/i.exec(texte);
    return { ok: regexResult !== null };
}
function onButtonClick() {
    alert("click !");
}
react_1.storiesOf('FinanceurInput', module)
    .addWithInfo('Standard', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, null)),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "hover" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "hover", ReadOnly: false })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "focus" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "focus" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "success", Validate: InputValidateTrue }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "success", Validate: InputValidateTrue })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "error", Validate: InputValidateFalse }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "error", Validate: InputValidateFalse })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "disable", Disable: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "disable", Disable: true })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "password", Type: TextInput_1.InputTypeEnum.Password, onChange: InputpasswordChange, Validate: InputpasswordValidate }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "password", Type: TextInput_1.InputTypeEnum.Password, onChange: InputpasswordChange, Validate: InputpasswordValidate })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "ReadOnly", ReadOnly: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "ReadOnly", ReadOnly: true })))); })
    .addWithInfo('With Bot label', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "info", InformationText: "balabalabalabalabalabalabalabaablabablalblab" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "info", InformationText: "balabalabalabalabalabalabalabaablabablalblab" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "success", Validate: InputValidateTrue, SuccessText: "Victoire pour le peuple !" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "success", Validate: InputValidateTrue, SuccessText: "Victoire pour le peuple !" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate, ErrorText: "Le mot de passe doit contenir 1 minuscule, 1 majuscule, 1 chiffre, 1 caractère spécial, et doit faire entre 8 et 16 caractères", InformationText: "Ceci est une infos. Très utile. Oui.", SuccessText: "Ce mot de passe est robuste. Comm... non." }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate, ErrorText: "Le mot de passe doit contenir 1 minuscule, 1 majuscule, 1 chiffre, 1 caractère spécial, et doit faire entre 8 et 16 caractères", InformationText: "Ceci est une infos. Très utile. Oui.", SuccessText: "Ce mot de passe est robuste. Comm... non." })))); })
    .addWithInfo('With Top Label', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait..." })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Placeholder: "hover" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Value: "hover" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Placeholder: "focus" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Value: "focus" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Placeholder: "success", Validate: InputValidateTrue }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Value: "success", Validate: InputValidateTrue })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Placeholder: "error", Validate: InputValidateFalse }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Value: "error", Validate: InputValidateFalse })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Placeholder: "disable", Disable: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Value: "disable", Disable: true })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Placeholder: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Tapez quelque chose... s'il-vous-plait...", Value: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Alors ici c'est surtout pour voir ce qu'il ce passe si on dépasse la ligne.", Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Alors ici c'est surtout pour voir ce qu'il ce passe si on dépasse la ligne.", Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Alors ici c'est surtout pour voir ce qu'il ce passe si on dépasse la ligne." })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Width: "400px", Label: "Alors ici c'est surtout pour voir ce qu'il ce passe si on dépasse la ligne, mais en plus long.", Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Width: "400px", Label: "Alors ici c'est surtout pour voir ce qu'il ce passe si on dépasse la ligne, mais en plus long.", Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Width: "400px", Label: "Alors ici c'est surtout pour voir ce qu'il ce passe si on dépasse la ligne, mais en plus long." })))); })
    .addWithInfo('With Icon (left)', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Pour repair", Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Pour repair", Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Pour repair" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B") })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), Placeholder: "hover" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Value: "hover" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Placeholder: "focus" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), Value: "focus" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Placeholder: "success", Validate: InputValidateTrue }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), Value: "success", Validate: InputValidateTrue })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), Placeholder: "error", Validate: InputValidateFalse }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Value: "error", Validate: InputValidateFalse })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Placeholder: "disable", Disable: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), Value: "disable", Disable: true })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), Placeholder: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Value: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate })))); })
    .addWithInfo('With Icon (right)', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Label: "Pour repair", Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Pour repair", Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Label: "Pour repair" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "hover" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "hover" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "focus" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "focus" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "success", Validate: InputValidateTrue }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "success", Validate: InputValidateTrue })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "error", Validate: InputValidateFalse }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "error", Validate: InputValidateFalse })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "disable", Disable: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "disable", Disable: true })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate })))); })
    .addWithInfo('With Label and Icon', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "Valeur" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, InformationText: "Ceci est une infos. Très utile. Oui. Même qu'elle est super longue.", Label: "Bien le bienvenue à toutes et tous dans cette foire." }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, InformationText: "Ceci est une infos. Très utile. Oui. Même qu'elle est super longue.", Label: "Bien le bienvenue à toutes et tous dans cette foire." })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Placeholder: "hover", InformationText: "Ceci est une infos. Très utile. Oui." }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Value: "hover", InformationText: "Ceci est une infos. Très utile. Oui." })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "focus", InformationText: "Ceci est une infos. Très utile. Oui." }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "focus", InformationText: "Ceci est une infos. Très utile. Oui." })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Placeholder: "success", Validate: InputValidateTrue, SuccessText: "Ce mot de passe est robuste. Comm... non.", Label: "cliquez pour victorier" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "success", Validate: InputValidateTrue, SuccessText: "Ce mot de passe est robuste. Comm... non." })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "error", Validate: InputValidateFalse, ErrorText: "Le mot de passe doit contenir 1 minuscule, 1 majuscule, 1 chiffre, 1 caractère spécial, et doit faire entre 8 et 16 caractères" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Value: "error", Validate: InputValidateFalse, ErrorText: "Le mot de passe doit contenir 1 minuscule, 1 majuscule, 1 chiffre, 1 caractère spécial, et doit faire entre 8 et 16 caractères", Label: "cliquez pour perdoyer" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Placeholder: "disable", Disable: true, InformationText: "Ceci est une infos. Très utile. Oui.", Label: "Au revoir" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "disable", Disable: true, InformationText: "Ceci est une infos. Très utile. Oui.", Label: "Au revoir" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Placeholder: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate, ErrorText: "Le mot de passe doit contenir 1 minuscule, 1 majuscule, 1 chiffre, 1 caractère spécial, et doit faire entre 8 et 16 caractères", InformationText: "Ceci est une infos. Très utile. Oui.", SuccessText: "Ce mot de passe est robuste. Comm... non.", Label: "mdp bonjour" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Value: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate, ErrorText: "Le mot de passe doit contenir 1 minuscule, 1 majuscule, 1 chiffre, 1 caractère spécial, et doit faire entre 8 et 16 caractères", InformationText: "Ceci est une infos. Très utile. Oui.", SuccessText: "Ce mot de passe est robuste. Comm... non.", Label: "mdp bonjour" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Placeholder: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate, ErrorText: "Le mot de passe doit contenir 1 minuscule, 1 majuscule, 1 chiffre, 1 caractère spécial, et doit faire entre 8 et 16 caractères", InformationText: "Ceci est une infos. Très utile. Oui.", SuccessText: "Ce mot de passe est robuste. Comm... non.", Label: "mdp au revoir", Disable: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "password", Type: TextInput_1.InputTypeEnum.Password, Validate: InputpasswordValidate, ErrorText: "Le mot de passe doit contenir 1 minuscule, 1 majuscule, 1 chiffre, 1 caractère spécial, et doit faire entre 8 et 16 caractères", InformationText: "Ceci est une infos. Très utile. Oui.", SuccessText: "Ce mot de passe est robuste. Comm... non.", Label: "mdp au revoir", Disable: true })))); })
    .addWithInfo('Require', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, null)),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Require: true, Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Require: true, Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Require: true })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Require: true, Label: "Bonjour", Placeholder: "hover" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Require: true, Label: "Bonjour", Value: "hover" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Require: true, Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Gauche, Placeholder: "focus" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Require: true, Icon: React.createElement("span", null, "\u266B"), IconPos: TextInput_1.PosIconEnum.Droite, Value: "focus" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Require: true, Placeholder: "success", Validate: InputValidateTrue, SuccessText: "Victoire pour le peuple." }),
        "\u2003",
        React.createElement(TextInput_1.default, { Require: true, Value: "success", Validate: InputValidateTrue, Label: "ah ?", SuccessText: "Victoire pour le peuple." })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Placeholder: "error", Validate: InputValidateFalse, ErrorText: "Réessayer encore." }),
        "\u2003",
        React.createElement(TextInput_1.default, { Value: "error", Validate: InputValidateFalse, ErrorText: "Réessayer encore." })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Require: true, Placeholder: "disable", Disable: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Require: true, Value: "disable", Disable: true })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Require: true, Placeholder: "password", Type: TextInput_1.InputTypeEnum.Password, onChange: InputpasswordChange, Validate: InputpasswordValidate }),
        "\u2003",
        React.createElement(TextInput_1.default, { Require: true, Value: "password", Type: TextInput_1.InputTypeEnum.Password, onChange: InputpasswordChange, Validate: InputpasswordValidate })))); })
    .addWithInfo('ComboBox', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "empty" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "invalid idx", ComboItems: ["1", "2", "3", "4"], ComboItemSelectIdx: -4 }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "invalid idx", ComboItems: ["1", "2", "3", "4"], ComboItemSelectIdx: -1 }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "invalid idx", ComboItems: ["1", "2", "3", "4"], ComboItemSelectIdx: 4 })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "placeholder", ComboItems: ["1", "2", "3", "4"] }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "placeholder", ComboItemSelectIdx: 0, ComboItems: ["1", "2", "3", "4"] })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "focus", ComboItems: ["bonjour", "bonjour", "bonjour", "bonjour"] }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "focus", ComboItemSelectIdx: 1, ComboItems: ["bonjour", "bonjour", "bonjour", "bonjour"] })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "success", ComboItems: ["1", "2", "3", "4"], Validate: InputValidateTrue }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "success", ComboItemSelectIdx: 2, ComboItems: ["1", "2", "3", "4"], Validate: InputValidateTrue })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "error", ComboItems: ["1", "2", "3", "4"], Validate: InputValidateTrue }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "error", ComboItemSelectIdx: 3, ComboItems: ["1", "2", "3", "4"], Validate: InputValidateTrue })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "disable", ComboItems: ["1", "2", "3", "4"], Disable: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "disable", ComboItemSelectIdx: 1, ComboItems: ["1", "2", "3", "4"], Disable: true })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "icons", ComboItems: ["1", "2", "3", "4"], Icon: React.createElement("span", null, "\u266B") }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "icons", ComboItemSelectIdx: 1, ComboItems: ["1", "2", "3", "4"], Icon: React.createElement("span", null, "\u266B") })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "taille", ComboItems: ["parce qu'il y a besoin de place", "2", "3", "4"], Width: "300px" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "taille", ComboItemSelectIdx: 1, ComboItems: ["parce qu'il y a besoin de place", "2", "3", "4"], Width: "300px" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "label", ComboItems: ["parce qu'il y a besoin de place", "2", "3", "4"], Label: "Bonjour" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "label", ComboItemSelectIdx: 1, ComboItems: ["parce qu'il y a besoin de place", "2", "3", "4"], Label: "Bonjour" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "success", ComboItems: ["1", "2", "3", "4"], Validate: InputValidateTrue, SuccessText: "victoire", InformationText: "click !" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "success", Icon: React.createElement("span", null, "\u266B"), ComboItemSelectIdx: 2, ComboItems: ["1", "2", "3", "4"], Validate: InputValidateTrue, SuccessText: "victoire", InformationText: "click !" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "error", Icon: React.createElement("span", null, "\u266B"), ComboItems: ["1", "2", "3", "4"], Validate: InputValidateTrue, ErrorText: "defaite", InformationText: "click !" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.ComboBox, Placeholder: "error", ComboItemSelectIdx: 3, ComboItems: ["1", "2", "3", "4"], Validate: InputValidateTrue, ErrorText: "defaite", InformationText: "click !" })))); })
    .addWithInfo('Button', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "" }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "", onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "", Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "", Secondary: true, onClick: onButtonClick })),
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "bonjur" }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Secondary: true, onClick: onButtonClick })),
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, Secondary: true, onClick: onButtonClick })),
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, Secondary: true, onClick: onButtonClick })),
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, TwoLines: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, TwoLines: true, onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, TwoLines: true, Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, TwoLines: true, Secondary: true, onClick: onButtonClick })),
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "", RoundAngle: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "", RoundAngle: true, onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "", RoundAngle: true, Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "", RoundAngle: true, Secondary: true, onClick: onButtonClick })),
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "bonjur", RoundAngle: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", RoundAngle: true, onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", RoundAngle: true, Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", RoundAngle: true, Secondary: true, onClick: onButtonClick })),
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, RoundAngle: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, RoundAngle: true, onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, RoundAngle: true, Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", Disable: true, RoundAngle: true, Secondary: true, onClick: onButtonClick })),
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, RoundAngle: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, RoundAngle: true, onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, RoundAngle: true, Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, RoundAngle: true, Secondary: true, onClick: onButtonClick })),
    React.createElement("p", null,
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, Disable: true, RoundAngle: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, Disable: true, RoundAngle: true, onClick: onButtonClick }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, Disable: true, RoundAngle: true, Secondary: true }),
        "\u2003",
        React.createElement(Button_1.default, { Text: "bonjur", TwoLines: true, Disable: true, RoundAngle: true, Secondary: true, onClick: onButtonClick })))); })
    .addWithInfo('Number', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Placeholder: "placeholder" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Value: "Valeur" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Placeholder: "hover" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Value: "5", ReadOnly: false })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Placeholder: "focus" }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Value: "911" })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Placeholder: "success", Validate: InputValidateTrue }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Value: "76", ReadOnly: false, Validate: InputValidateTrue })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Placeholder: "error", Validate: InputValidateFalse }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Value: "654", Validate: InputValidateFalse })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Placeholder: "disable", Disable: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Value: "6878", Disable: true })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Placeholder: "password", onChange: InputpasswordChange, Validate: InputpasswordValidate }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Value: "38438", onChange: InputpasswordChange, Validate: InputpasswordValidate })),
    React.createElement("p", null,
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Placeholder: "ReadOnly", ReadOnly: true }),
        "\u2003",
        React.createElement(TextInput_1.default, { Type: TextInput_1.InputTypeEnum.Number, Value: "3846", ReadOnly: true })))); })
    .addWithInfo('Text Area', '', function () { return (React.createElement("div", { style: { padding: "16px" } },
    React.createElement(TextArea_1.default, { InformationText: "bdzlkbqdlkbdlzqbfl bqzlkfbqzlibfilqzbfliqzb fliqbzlifbqlizbf liqbzflibqzlifblqizbfilqbzlifbqlib fzlqbzlifb qlizbflqbzflib" }),
    React.createElement(TextArea_1.default, { Placeholder: "Place older than me !" }),
    React.createElement(TextArea_1.default, { Placeholder: "Place older than me !", Value: "blablablablablablablablablablablablablablablablabalblablablablbalbalbalblablablablablablablablablbalbalbab" }),
    React.createElement(TextArea_1.default, { Placeholder: "Place older than me !", Require: true }),
    React.createElement(TextArea_1.default, { Placeholder: "Place older than me !", Disable: true }),
    React.createElement(TextArea_1.default, { Placeholder: "Place older than me !", ReadOnly: true }),
    React.createElement(TextArea_1.default, { Placeholder: "Place older than me !", ErrorText: "erreur hahhahhahahha", Validate: InputValidateFalse }),
    React.createElement(TextArea_1.default, { Placeholder: "Place older than me !", SuccessText: "reusii hihihihihih", Validate: InputValidateTrue }))); });
//# sourceMappingURL=index.stories.js.map