"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var BaseControl_1 = require("../_Common/BaseControl/BaseControl");
var TypeNumberControl_1 = require("../_Common/Validation/TypeNumberControl");
var core_1 = require("@blueprintjs/core");
var typestyle_1 = require("typestyle");
var UpNumber = (function (_super) {
    __extends(UpNumber, _super);
    function UpNumber(p, c) {
        var _this = _super.call(this, p, c) || this;
        _this.round = function (value, decimals) {
            decimals = Math.abs(parseInt(decimals)) || 0;
            var multiplier = Math.pow(10, decimals);
            return Math.round(value * multiplier) / multiplier;
        };
        _this.handleNumericChange = function (valueAsNumber, valueAsString) {
            if (_this.props.decimalPlace != null) {
                var _newValue = _this.round(valueAsNumber, _this.props.decimalPlace);
                if (isNaN(valueAsNumber)) {
                    _this.handleChangeEvent(_this.state.value);
                }
                else if (_newValue === valueAsNumber && _newValue.toString() !== valueAsString) {
                    _this.handleChangeEvent(valueAsString);
                }
                else {
                    _this.handleChangeEvent(valueAsNumber);
                }
            }
            else {
                _this.handleChangeEvent(valueAsNumber);
            }
        };
        _this.state = {
            value: p.value
        };
        _this._validationManager.addControl(new TypeNumberControl_1.default(_this.props.decimalPlace === 0, _this.props.min, _this.props.max));
        return _this;
    }
    UpNumber.prototype.getValue = function (value) {
        return value;
    };
    UpNumber.prototype.renderControl = function () {
        var _a = this.props, isRequired = _a.isRequired, onChange = _a.onChange, readonly = _a.readonly, decimalPlace = _a.decimalPlace, stepSize = _a.stepSize, value = _a.value, tooltip = _a.tooltip;
        var s = typestyle_1.style({
            $nest: {
                "& .pt-input-group": { flex: "1 1 auto" }
            }
        });
        return (React.createElement(core_1.NumericInput, { className: s, value: this.state.value, stepSize: stepSize, majorStepSize: stepSize ? stepSize + 10 : 10, onValueChange: this.handleNumericChange, minorStepSize: 1 / (Math.pow(10, this.props.decimalPlace)) }));
    };
    UpNumber.defaultProps = {
        decimalPlace: 2,
        showError: true,
        max: Infinity,
        min: -Infinity
    };
    return UpNumber;
}(BaseControl_1.BaseControlComponent));
exports.default = UpNumber;
//# sourceMappingURL=UpNumber.js.map