/// <reference types="react" />
import * as React from 'react';
import { ThemedProps } from '../../../Common/theming/types';
export declare type Size = 'small' | 'normal' | 'large';
export interface UpToggleStyledProps extends ThemedProps {
    className?: string;
}
export interface UpToggleProps {
    value: any;
    checked?: boolean;
    defaultChecked?: boolean;
    disabled?: boolean;
    onChange?: (event) => void;
    onFocus?: (event) => void;
    onBlur?: (event) => void;
    icons?: any;
    size?: Size;
    className?: string;
}
export default class UpToggle extends React.PureComponent<UpToggleProps, any> {
    previouslyChecked: boolean;
    input: any;
    moved: boolean;
    startX: number;
    activated: boolean;
    static defaultProps: {
        icons: {
            checked: JSX.Element;
            unchecked: JSX.Element;
        };
        size: string;
    };
    constructor(props: any);
    private pointerCoord(event);
    componentWillReceiveProps(nextProps: any): void;
    handleClick: (event: any) => void;
    handleTouchStart: (event: any) => void;
    handleTouchMove: (event: any) => void;
    handleTouchEnd: (event: any) => void;
    handleFocus: (event: any) => void;
    handleBlur: (event: any) => void;
    handleChangeEvent: (event: any) => void;
    getIcon: (type: any) => any;
    getTrackHeight: () => string;
    getTrackWidth: () => string;
    getThumbWidth: () => string;
    getThumbHeight: () => string;
    getTrackBorder: () => string;
    getThumbBorder: () => string;
    getThumbPosition: () => {
        top: string;
        left: string;
    };
    getThumbSelectedPosition: () => {
        left: string;
    };
    getTrackXPosition: () => {
        top: string;
        bottom: string;
        right: string;
    };
    getTrackCheckPosition: () => {
        top: string;
        bottom: string;
        left: string;
    };
    render(): JSX.Element;
}
